	DATA

GWVA_FMENU_POPUP_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_CLICK,GWVA_FMENU_POPUP_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_CLICK
; Asm label   : GWVA_FMENU_POPUP_PRG_CLICK
; Description : Mthode de traitement d'un clic sur un popup
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer d'entre typ GWVA_FORM_CLICK_IN
; in  : d0.l = [ X.w | num gem.w ]
; in  : d1.l = [ Y.w | mouse button.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 29/03/98 : Appel du form_button
;------------------------------------------------------------------------------

GWVA_FMENU_POPUP_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_FORM_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_popupclick_car_on_popupclick_consomme

	;-----------------------------------;

	cmp.w GWVA_FPOP_OBJ_MAIN_IDX(a0),d0
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0-d2/a0-a1
	objc_offset GWVA_FORM_CLICK_IN_TREE_PTR(a1),d0
	load.l d0-d2/a0-a1
	movem.w int_out+2,d3-d4	; position x,y

	save.l d0-d4/a0-a1
	move.w GWVA_FPOP_OBJ_POP_TREE(a0),d0
	lea GWVA_RSC_TMP_ADD_TREE,a0
	bsr GWVA_RSC_RETURN_PTR_ON_TREE
	load.l d0-d4/a0-a1

	lea GWVA_RSC_TMP_MENU_OBJ,a4
	move.l GWVA_RSC_TMP_ADD_TREE,mn_tree(a4)
	move.w GWVA_FPOP_OBJ_POP_IDX(a0),mn_menu(a4)
	move.w GWVA_FPOP_OBJ_SELECTION(a0),mn_item(a4)
	clr.w mn_scroll(a4)
	clr.w mn_keystate(a4)

	save.l d0-d2/a0-a1
	menu_popup #GWVA_RSC_TMP_MENU_OBJ,d3,d4,#GWVA_RSC_TMP_MENU_OBJ
	move d0,d4
	load.l d0-d2/a0-a1

	cmp.w #1,d4
	bne .pas_de_retour_popup

	lea GWVA_RSC_TMP_MENU_OBJ,a4
	move.w mn_item(a4),d3

	cmp GWVA_FPOP_OBJ_SELECTION(a0),d3		; ancien = nouveau ?
	beq .meme_selection

	move.w d3,GWVA_FPOP_OBJ_SELECTION(a0)	; mettre nouveau

	save.l d0-d2/a0-a1			; d3 est perdu
	move GWVA_FPOP_OBJ_POP_TREE(a0),d0
	move d3,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a2
	load.l d0-d2/a0-a1

	save.l d0-d2/a0-a2
	move ([a1,GWVA_FORM_CLICK_IN_WIND_PTR],GWVA_WRSC_OBJ_TREE),d0
	move GWVA_FPOP_OBJ_MAIN_IDX(a0),d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a3
	load.l d0-d2/a0-a2

	COPY_STRING_0 a2,a3

	save.l d0-d2/a0-a1
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),a2	; oblig, dsol
	lea GWVA_WFORM_FPOPUP_TMP_OBJ_LIST,a1
	move.w GWVA_FPOP_OBJ_MAIN_IDX(a0),(a1)
	move.w #1,2(a1)
	move.w #GWVA_WRSC_CTE_REDRAW_PART_END_LIST,4(a1)
	move.l a2,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS
	load.l d0-d2/a0-a1

	; Attention : positionner les paramtres d'entre + sauver les courants
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_CHANGED

	;-----------------------------------;

.meme_selection:
.pas_de_retour_popup:
.pas_popupclick_car_on_popupclick_consomme:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

 BSS
GWVA_RSC_TMP_MENU_OBJ:		ds.b LONG_STRUC_MENU
GWVA_WFORM_FPOPUP_TMP_OBJ_LIST:	ds.w 2+1
 TEXT
