	DATA

GWVA_WBITM_DEFAULT_METHODLIST:
; Mthodes publiques
; Mthodes prives
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_WBITM_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_WBITM_PRG_DELETE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_OPEN,GWVA_WBITM_PRG_OPEN

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_FULL,GWVA_WBITM_PRG_WM_FULL
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_SIZE,GWVA_WBITM_PRG_WM_SIZE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_MOVE,GWVA_WBITM_PRG_WM_MOVE

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_REDRAW,GWVA_WBITM_PRG_WM_REDRAW

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_ARROW,GWVA_WBITM_PRG_ARROW
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_HSLID,GWVA_WBITM_PRG_HSLID
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_VSLID,GWVA_WBITM_PRG_VSLID

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_SET_PALETTE,GWVA_WBITM_PRG_SET_PALETTE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY,GWVA_WIND_PRG_MOVE_SLIDERS_WITH_KEY
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_CALC_SLIDERS,GWVA_WBITM_PRG_CALC_SLIDERS
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_SIZE
; Asm label   : GWVA_WBITM_PRG_SIZE
; Method name : GWVA_METHOD_WM_MOVE
; Asm label   : GWVA_WBITM_PRG_MOVE
; Description : Dplacement d'une fentre bitmap avec un ventuel changement de taille
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  dplacer/redimensionner
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 11/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_WM_SIZE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_SIZE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_size_car_on_size_consome

	;-----------------------------------;
	; !! attention  a0-a2/d0

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	;------------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_SIZED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_SIZED

.pas_size_car_on_size_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	;-----------------------------------;

GWVA_WBITM_PRG_WM_MOVE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_MOVE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_move_car_on_move_consome

	;-----------------------------------;
	; !! attention  a0-a2/d0

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	;------------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_MOVED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_MOVED

.pas_move_car_on_move_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_FULL
; Asm label   : GWVA_WBITM_PRG_FULL
; Description : demande de Full d'une fentre bitmap
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  fuller
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 11/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_WM_FULL:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_FULL
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_full_car_on_full_consome

	;-----------------------------------;
	; !! attention  a0-a2/d0

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	;------------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_FULLED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_FULLED

.pas_full_car_on_full_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_OPEN
; Asm label   : GWVA_WBITM_PRG_OPEN
; Description : Ouverture d'une fentre bitmap
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : d0.w = handle GEM de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;	   ou GWVA_ERROR_WIND_BAD_HANDLE
;	   ou GWVA_ERROR_WIND_OPEN
;	   ou GWVA_ERROR_WIND_MOTHER_NOT_OPENED
;
; 11/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_OPEN:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_OPEN
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_open_car_on_open_consome

	;-----------------------------------;

	; !! attention  a0 et d0

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .methode_consomme_mais_pas_traitement_par_pere

	;------------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_OPENED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_OPENED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.methode_consomme_mais_pas_traitement_par_pere:
.pas_open_car_on_open_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_SET_PALETTE
; Asm label   : GWVA_WBITM_PRG_SET_PALETTE
; Description : Met la palette de la fentre bitmap
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_SET_PALETTE:
; pas de before

	;-----------------------------------;

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	bne.s .window_namified

	move.l GWVA_WBITM_OBJ_PAL_PTR(a0),d0
	beq.s .pas_de_palette

	save.l a0
	move.l d0,a0
	bsr GWVA_ROOT_SET_FALCON_PALETTE
	load.l a0

	;-----------------------------------;

; pas de after

.common_end:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.pas_de_palette:
.window_namified:
	bsr GWVA_ROOT_SET_DESK_PALETTE
	bra.s .common_end

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_HSLID
; Asm label   : GWVA_WBITM_PRG_HSLID
; Description : Ordre de mouvement du slider horizontal
;
; Rq  : 
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_HSLID:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_HSLID
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_hslid_car_on_hslid_consome

	;-----------------------------------;

	; !! attention  a1 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	load.l a1

	move GWVA_WBITM_OBJ_IMG_WIDTH(a0),d3	; largeur buffer

	sub d2,d3
	move.w bmsg_slider_percent(a1),d1		; % du GEM
	mulu d3,d1
	divu #1000,d1
	move d1,GWVA_WBITM_OBJ_AFF_DX(a0)

	bsr GWVA_WBITM_CALCULATE_PHSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_HSLIDED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_HSLIDED

.pas_hslid_car_on_hslid_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_VSLID
; Asm label   : GWVA_WBITM_PRG_VSLID
; Description : Ordre de mouvement du slider vertical
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_VSLID:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_VSLID
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_vslid_car_on_vslid_consome

	;-----------------------------------;

	; !! attention  a1 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	load.l a1

	move.w GWVA_WBITM_OBJ_IMG_HEIGHT(a0),d2	; hauteur buffer
	move.w bmsg_slider_percent(a1),d1		; % du GEM
	sub.w d3,d2
	mulu d2,d1
	divu #1000,d1
	move.w d1,GWVA_WBITM_OBJ_AFF_DY(a0)

	bsr GWVA_WBITM_CALCULATE_PVSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_VSLIDED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_VSLIDED

.pas_vslid_car_on_vslid_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_ARROW
; Asm label   : GWVA_WBITM_PRG_ARROW
; Description : Ordre de mouvement d'un slider
;
; Rq  : Mouvement par page ou d'un lment
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 25/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_ARROW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_ARROW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_arrow_car_on_arrow_consome

	;-----------------------------------;

	; !! attention  a1 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	load.l a1

	move.w bmsg_arrowed_action(a1),d4		; action ?

	cmp.w #WA_UPPAGE,d4
	bne.s .pas_page_h
	sub.w d3,GWVA_WBITM_OBJ_AFF_DY(a0)
.pas_page_h:
	cmp.w #WA_DNPAGE,d4
	bne.s .pas_page_b
	add.w d3,GWVA_WBITM_OBJ_AFF_DY(a0)
.pas_page_b:
	cmp.w #WA_UPLINE,d4
	bne.s .pas_ligne_h
	sub.w #1,GWVA_WBITM_OBJ_AFF_DY(a0)
.pas_ligne_h:
	cmp.w #WA_DNLINE,d4
	bne.s .pas_ligne_b
	add.w #1,GWVA_WBITM_OBJ_AFF_DY(a0)
.pas_ligne_b:
	cmp.w #WA_LFPAGE,d4
	bne.s .pas_page_g
	sub.w d2,GWVA_WBITM_OBJ_AFF_DX(a0)
.pas_page_g:
	cmp.w #WA_RTPAGE,d4
	bne.s .pas_page_d
	add.w d2,GWVA_WBITM_OBJ_AFF_DX(a0)
.pas_page_d:
	cmp.w #WA_LFLINE,d4
	bne.s .pas_col_g
	sub.w #1,GWVA_WBITM_OBJ_AFF_DX(a0)
.pas_col_g:
	cmp.w #WA_RTLINE,d4
	bne.s .pas_col_d
	add.w #1,GWVA_WBITM_OBJ_AFF_DX(a0)
.pas_col_d:

	move GWVA_WBITM_OBJ_IMG_HEIGHT(a0),d4
*	add.w #1,d4		; numro de ligne
	sub d3,d4
	cmp.w GWVA_WBITM_OBJ_AFF_DY(a0),d4	; dpassement de la dernire ligne visible
	bge.s .ok2
	move d4,GWVA_WBITM_OBJ_AFF_DY(a0)
.ok2:
	tst GWVA_WBITM_OBJ_AFF_DY(a0)
	bpl.s .ok1
	clr GWVA_WBITM_OBJ_AFF_DY(a0)
.ok1:
	move GWVA_WBITM_OBJ_IMG_WIDTH(a0),d4
	sub d2,d4
	cmp.w GWVA_WBITM_OBJ_AFF_DX(a0),d4
	bge.s .ok4
	move d4,GWVA_WBITM_OBJ_AFF_DX(a0)
.ok4:
	tst GWVA_WBITM_OBJ_AFF_DX(a0)
	bpl.s .ok3
	clr GWVA_WBITM_OBJ_AFF_DX(a0)
.ok3:

	bsr GWVA_WBITM_CALCULATE_PVSLIDE
	bsr GWVA_WBITM_CALCULATE_PHSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	;-----------------------------------;
	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_ARROWED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_ARROWED

.pas_arrow_car_on_arrow_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_CALC_SLIDERS
; Asm label   : GWVA_WBITM_PRG_CALC_SLIDERS
; Description : Recalcul les taille/positions des sliders de la fentre et les
;	    affichage
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 25/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_CALC_SLIDERS:
; pas de before

	;-----------------------------------;

; Appel des mthodes de la fentre

	bsr GWVA_WBITM_CALCULATE_HVSLIDE	; ici il faut forcer le raffichage
	bsr GWVA_WBITM_CALCULATE_PVSLIDE	; des slides car la fentre peut avoir
	bsr GWVA_WBITM_CALCULATE_WHSLIDE	; chang de taille
	bsr GWVA_WBITM_CALCULATE_PHSLIDE

	;-----------------------------------;

; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WBITM_PRG_WM_REDRAW
; Description : Mthode de redessin d'une partie du contenu de la fentre
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED si le message est pour cette fentre
;	   GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE
; 	   GWVA_WBITM_CTE_REDRAW_IS_POSSIBLE
; 	   GWVA_WBITM_CTE_REDRAW_IS_NOT_POSSIBLE
;
; 10/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_WM_REDRAW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
	bne .methode_consomme_mais_pas_traitement_par_pere

	;-----------------------------------;

	move.w GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2,d3
	cmp.w GWVA_WBITM_OBJ_NB_BITPLANES(a0),d3
	bne .pas_le_meme_nb_plan

	save.l a0-a2/d0

	ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE
	lea bmsg_xywh(a1),a0
	bsr GWVA_ROOT_HIDE_MOUSE_XYWH
	else
	bsr GWVA_ROOT_HIDE_MOUSE
	endc	; ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE

	movem.l (sp),a0-a2/d0

	movem.w bmsg_xywh(a1),d0-d3

	add.w d0,d2
	subq #1,d2
	add.w d1,d3
	subq #1,d3
	movem.w d0-d3,GWVA_WBITM_ZONE_CLIPPING_REDRAWING

	save.l a0

	vs_clip #1,d0,d1,d2,d3

	move.l (sp),a0

	lea GWVA_WBITM_MFDB_SRC,a2
	move.l GWVA_WBITM_OBJ_DATA_PTR(a0),(a2)+	; pointeur image
	move.l GWVA_WBITM_OBJ_IMG_WIDTH(a0),(a2)+	; largeur/hauteur image pixel

	move.w GWVA_WBITM_OBJ_IMG_WIDTH(a0),d5
	add.w #15,d5
	ext.l d5
	divu #16,d5
	move.w d5,(a2)+			; largeur image en mots

	move.w #0,(a2)+			; device dependent

	move.w GWVA_WBITM_OBJ_NB_BITPLANES(a0),(a2)+
	clr.w (a2)+				; reservs
	clr.w (a2)+
	clr.w (a2)+

	clr.l GWVA_WBITM_MFDB_DEST

	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE

	movem.w GWVA_WBITM_ZONE_CLIPPING_REDRAWING,d4-d7
	sub.w d0,d4
	sub.w d1,d5
	sub.w d0,d6
	sub.w d1,d7
	add.w GWVA_WBITM_OBJ_AFF_DX(a0),d4
	add.w GWVA_WBITM_OBJ_AFF_DY(a0),d5
	add.w GWVA_WBITM_OBJ_AFF_DX(a0),d6
	add.w GWVA_WBITM_OBJ_AFF_DY(a0),d7
	movem.w d4-d7,ptsin

	movem.w GWVA_WBITM_ZONE_CLIPPING_REDRAWING,d0-d3
	movem.w d0-d3,ptsin+4*2

	vro_cpyfm #S_ONLY,#GWVA_WBITM_MFDB_SRC,#GWVA_WBITM_MFDB_DEST
	
	ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE
	bsr GWVA_ROOT_SHOW_MOUSE
	else
	bsr GWVA_ROOT_SHOW_MOUSE
	endc	; ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE

	vs_clip #0,#0,#0,#0,#0

	load.l a0

	load.l a0-a2/d0

	;-----------------------------------;
	; envoyer la mthode GWVA_METHOD_WM_REDRAWN

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

	moveq #GWVA_WBITM_CTE_REDRAW_IS_POSSIBLE,d7
.methode_consomme_mais_pas_traitement_par_pere:
.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts
.pas_le_meme_nb_plan:
	moveq #GWVA_WBITM_CTE_REDRAW_IS_NOT_POSSIBLE,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WBITM_PRG_DELETE
; Description : Mthode de destruction de la fentre bitmap
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 10/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_DELETE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	bftst GWVA_WBITM_OBJ_PROPERTIES(a0){GWVA_WBITM_OLBIT_FREEDATA:1}
	beq.s .pas_mfree_data
	move.l GWVA_WBITM_OBJ_DATA_PTR(a0),d0
	beq.s .pas_mfree_data
	save.l a0
	MFREE d0
	load.l a0
	clr.l GWVA_WBITM_OBJ_DATA_PTR(a0)
.pas_mfree_data:
	bftst GWVA_WBITM_OBJ_PROPERTIES(a0){GWVA_WBITM_OLBIT_FREEPAL:1}
	beq.s .pas_mfree_pal
	move.l GWVA_WBITM_OBJ_PAL_PTR(a0),d0
	beq.s .pas_mfree_pal
	save.l a0
	MFREE GWVA_WBITM_OBJ_PAL_PTR(a0)
	load.l a0
	clr.l GWVA_WBITM_OBJ_PAL_PTR(a0)
.pas_mfree_pal:

	;-------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	;-------------

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WBITM_PRG_CREATE_CONTENTS
; Description : Mthode de cration de la fentre bitmap
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou 
;	   GWVA_ERROR_WBITM_BAD_COLOR_NBR si le nombre de plan de l'image ne correspond pas  celui de l'cran
;	   ou erreurs de la classe WIND
;
; 10/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_PRG_CREATE:

	move.w GWVA_WBITM_OBJ_NB_BITPLANES(a0),d0
	cmp.w GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2,d0
	bne.s .pas_le_meme_nb_coul

	move.l GWVA_WBITM_OBJ_IMG_WIDTH(a0),GWVA_WIND_OBJ_CONTENTS_W(a0)
	clr.l GWVA_WBITM_OBJ_AFF_DX(a0)

	;-------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_creation

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_creation:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.pas_le_meme_nb_coul:
	move.w #GWVA_ERROR_WBITM_BAD_COLOR_NBR,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WBITM_CALCULATE_PHSLIDE
; Description : Calcul la position du curseur colonne d'affichage, ainsi que
; Description : la position ventuelle d'un slider horizontal et l'affiche.
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_CALCULATE_PHSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	; d2.w : largeur visible du contenu de la fentre

	move GWVA_WBITM_OBJ_IMG_WIDTH(a0),d0	; largeur image totale
	move.w d0,d1
	sub.w d2,d1				; indice max de la 1er colonne affiche

	cmp.w GWVA_WBITM_OBJ_AFF_DX(a0),d1
	ble.s .min
	move.w GWVA_WBITM_OBJ_AFF_DX(a0),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:
	move.w d1,GWVA_WBITM_OBJ_AFF_DX(a0)

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_HSLIDER

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WBITM_CALCULATE_WHSLIDE
; Description : Calcul la taille du slider horizontal et l'affiche
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_CALCULATE_WHSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	; d2.w largeur visible

	move.w GWVA_WBITM_OBJ_IMG_WIDTH(a0),d0	; largeur max de la fentre
	move.w GWVA_WBITM_OBJ_AFF_DX(a0),d1		; indice de la premire ligne affiche

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_HSLIDER
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WBITM_CALCULATE_PVSLIDE
; Description : Calcul la position du curseur ligne d'affichage, ainsi que
; Description : la position ventuelle d'un slider vertical et l'affiche.
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_CALCULATE_PVSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	move.w d3,d2	; taille vertical visible du contenu de la fentre

; ST MAG 79
	move GWVA_WBITM_OBJ_IMG_HEIGHT(a0),d0	; hauteur totale de la fentre
*	add.w #1,d0

	move.w d0,d1
	sub.w d2,d1			; d1 = indice max de la 1er ligne affiche

	cmp.w GWVA_WBITM_OBJ_AFF_DY(a0),d1
	ble.s .min
	move.w GWVA_WBITM_OBJ_AFF_DY(a0),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WBITM_OBJ_AFF_DY(a0)	; d1 = 1er ligne vue

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_VSLIDER

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WBITM_CALCULATE_HVSLIDE
; Description : Calcul la taille du slider vertical, et l'affiche.
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WBITM_CALCULATE_HVSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	move.w d3,d2	; d2.w : taille vertical visible du contenu de la fentre

	move GWVA_WBITM_OBJ_IMG_HEIGHT(a0),d0	; hauteur max de la fentre
*	add #1,d0

	move.w GWVA_WBITM_OBJ_AFF_DY(a0),d1		; indice de la premire ligne affiche

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_VSLIDER

	rts

;------------------------------------------------------------------------------

 BSS

GWVA_WBITM_ZONE_CLIPPING_REDRAWING:	ds.w 4
GWVA_WBITM_MFDB_SRC:		ds.l 1	; buffers pour vro_cpyfm
			ds.w 8
GWVA_WBITM_MFDB_DEST:		ds.l 1
			ds.w 8

 TEXT
