	DATA

GWVA_WTEXT_DEFAULT_METHODLIST:
; Mthodes publiques
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WTEXT_CLEAR_BUFFER_AND_UPDATE,GWVA_WTEXT_PRG_CLEAR_BUFFER_AND_UPDATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WTEXT_CLEAR_BUFFER,GWVA_WTEXT_PRG_CLEAR_BUFFER
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WTEXT_WRITE_IN_BUFFER,GWVA_WTEXT_PRG_WRITE_IN_BUFFER
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WTEXT_WRITE_IN_WINDOW,GWVA_WTEXT_PRG_WRITE_IN_WINDOW
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WTEXT_WRITE_BUFFER,GWVA_WTEXT_PRG_WRITE_BUFFER_IN_WINDOW
; Mthodes prives
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES,GWVA_WTEXT_PRG_CORRECT_VISIBLE_SIZES

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_WTEXT_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_WTEXT_PRG_DELETE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_OPEN,GWVA_WTEXT_PRG_OPEN
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CLOSE,GWVA_WTEXT_PRG_CLOSE

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_FULL,GWVA_WTEXT_PRG_WM_FULL
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_SIZE,GWVA_WTEXT_PRG_WM_SIZE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_MOVE,GWVA_WTEXT_PRG_WM_MOVE

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_REDRAW,GWVA_WTEXT_PRG_WM_REDRAW

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_ARROW,GWVA_WTEXT_PRG_ARROW
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_HSLID,GWVA_WTEXT_PRG_HSLID
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_VSLID,GWVA_WTEXT_PRG_VSLID
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY,GWVA_WIND_PRG_MOVE_SLIDERS_WITH_KEY
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_CALC_SLIDERS,GWVA_WTEXT_PRG_CALC_SLIDERS
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WTEXT_CLEAR_BUFFER_AND_UPDATE
; Asm label   : GWVA_WTEXT_PRG_CLEAR_BUFFER_AND_UPDATE
; Description : Efface le buffer de texte, effectue un HOME et ractualise
; Description : graphiquement la fentre
;
; Rq  : Pas de ON_ ni de _ED
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 03/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_CLEAR_BUFFER_AND_UPDATE:
; pas de before

	;-----------------------------------;
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WTEXT_CLEAR_BUFFER
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WTEXT_WRITE_BUFFER
	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WTEXT_CLEAR_BUFFER
; Asm label   : GWVA_WTEXT_PRG_CLEAR_BUFFER
; Description : Efface le buffer de texte et effectue un HOME
;
; Rq  : Pas de ON_ ni de _ED
; Rq  : Pour avoir une visualisation de l'effacement du buffer (ractualisation
; Rq  : des sliders, affichage ...) il faut appeler la mthode :
; Rq  : GWVA_METHOD_WTEXT_WRITE_BUFFER
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 03/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_CLEAR_BUFFER:
; pas de before

	;-----------------------------------;
	move.l GWVA_WTEXT_OBJ_MALLOC(a0),a1

	move.w GWVA_WTEXT_OBJ_NB_COLONNES(a0),d0
	mulu GWVA_WTEXT_OBJ_NB_LIGNES(a0),d0
	addq.l #1,d0			; taille du buffer de caractre +0  la fin

.putspaces:	move.b #' ',(a1)+
	subq.l #1,d0
	bne.s .putspaces

	clr.b ([GWVA_WTEXT_OBJ_MALLOC,a0])		; buffer vide

	clr.l GWVA_WTEXT_OBJ_CUR_BUF_COL(a0)	; colonne 0, ligne 0 en criture
	clr.l GWVA_WTEXT_OBJ_CUR_AFF_COL(a0)	; colonne 0, ligne 0 en affichage
	clr.l GWVA_WTEXT_OBJ_BUF_COLONNE(a0)	; colonne 0, ligne 0 en criture
	clr.l GWVA_WTEXT_OBJ_AFF_COLONNE(a0)	; colonne 0, ligne 0 en affichage

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WTEXT_WRITE_BUFFER
; Asm label   : GWVA_WTEXT_PRG_WRITE_BUFFER_IN_WINDOW
; Description : Ecrit le buffer texte dans la fentre
;
; Rq  : Pas de ON_WRITE ni de WRITTEN
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 21/02/98 : Cration
; 08/03/98 : Passage en mthode
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_WRITE_BUFFER_IN_WINDOW:
; pas de before

	;-----------------------------------;

	btst #VSLIDE-8,GWVA_WIND_OBJ_FLAGS(a0)
	beq.s .colle	; slider vertical ? non -> on colle auto.
	
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLIDE	; pos vslide
	load.l a0
	move.w int_out+2,d0
	save.l d0/a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLSIZE
	load.l d0/a0
	move.w int_out+2,d1

	cmp.w #1000,d0
	beq.s .colle
	cmp.w #1000,d1
	bne.s .pas_colle

.colle:	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a0),GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
	; l'affichage suit l'criture dans le buffer
	bsr GWVA_WTEXT_CALCULATE_CURRENT_PRINT_LINE
.pas_colle:

	;-;

*	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW

	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0)
	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_COL(a0)
	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0)
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),GWVA_WTEXT_OBJ_CUR_AFF_COL(a0)

	bsr GWVA_WTEXT_CALCULATE_PVSLIDE
	bsr GWVA_WTEXT_CALCULATE_PHSLIDE
	;-;

	bsr GWVA_WTEXT_CALCULATE_HVSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WTEXT_WRITE_IN_WINDOW
; Asm label   : GWVA_WTEXT_PRG_WRITE_IN_WINDOW
; Description : Mthode pour crire une chaine dans la fentre avec un
;	    affichage immdiat
;
; Rq  : Pas de ON_WRITE ni de WRITTEN
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le texte (termin par un 0.b)
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_WRITE_IN_WINDOW:
; pas de before

	;-----------------------------------;

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WTEXT_WRITE_IN_BUFFER
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WTEXT_WRITE_BUFFER

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WTEXT_WRITE_IN_BUFFER
; Asm label   : GWVA_WTEXT_PRG_WRITE_IN_BUFFER
; Description : Mthode pour crire une chaine dans le buffer de la fentre.
;
; Rq  : Aucun affichage n'est effectu aprs cette mthode
; Rq  : Pas de ON_WRITE ni de WRITTEN
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le texte (termin par un 0.b)
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_WRITE_IN_BUFFER:
; pas de before

	;-----------------------------------;

	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a0),d0	; colonne actuelle d'criture
	ext.l d0
	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a0),d1	; ligne actuelle d'criture
	ext.l d1

	move GWVA_WTEXT_OBJ_NB_COLONNES(a0),d2	; largeur d'une ligne
	ext.l d2
	move GWVA_WTEXT_OBJ_NB_LIGNES(a0),d3	; hauteur fentre
	ext.l d3

	move.l GWVA_WTEXT_OBJ_MALLOC(a0),a2	; a2 pointe sur dbut du buffer

	move d1,d4
	mulu d2,d4
	add.l d0,d4
	lea 0(a2,d4.l),a2		; pointeur sur le curseur texte (premire position de caractre libre)
	
.next_car:	move.b (a1)+,d4		; MODIF LE 06/06/95 par WAX
	beq.s .its_0

	cmp.b #lf,d4		; lf rempli et retourne au dbut
	beq.s .its_lf
	cmp.b #rc,d4		; rc descend d'une ligne et retourne au dbut
	beq.s .its_rc
	
	move.b d4,(a2)+

	addq.l #1,d0		; +1 colonne pour le curseur texte
	cmp.l d0,d2
	bgt.s .no_end_line

.desc1lign:	clr.l d0			; 1er colonne
	addq.l #1,d1		; +1 ligne pour le curseur texte
	cmp.l d1,d3
	bgt.s .no_end_buf

	subq.l #1,d1		; on se remet sur la dernire ligne
	subq.w #1,GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0)	; tout le texte remonte d'une ligne (scroll)
	subq.w #1,GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0)

; debut du scroll d'une ligne du buffer

	move.l GWVA_WTEXT_OBJ_MALLOC(a0),a3
	move.l d2,d7
	mulu d3,d7
	sub.l d2,d7		; longeur  scroller
	beq.s .one_line

	divul #4,d6:d7

	tst.l d7
	beq.s .moins_de_4octets

.remonte1:	move.l (a3,d2.l),(a3)+
	subq.l #1,d7
	bne.s .remonte1

.moins_de_4octets:
	sub.w #1,d6
	bmi.s .pas_de_reste

.remonte2:	move.b (a3,d2.l),(a3)+
	dbf d6,.remonte2
.pas_de_reste:
.one_line:
	move.w d2,d7
	subq.w #1,d7
.put_spaces:move.b #' ',(a3)+
	dbf d7,.put_spaces

; fin du scroll d'une ligne du buffer

	sub.l d2,a2
.no_end_buf:
.no_end_line:
	bra.s .next_car

.its_lf:	move d2,d7		; attention : le line-feed fait tout !
	sub d0,d7
	subq #1,d7
.cp:	move.b #' ',(a2)+
	dbf d7,.cp
	sub.w d2,a2
	clr.l d0
	bra.s .next_car

.its_rc:	sub.w d0,a2
	add.w d2,a2
	bra.s .desc1lign

.its_0:	move.w d0,GWVA_WTEXT_OBJ_BUF_COLONNE(a0)
	move.w d1,GWVA_WTEXT_OBJ_BUF_LIGNE(a0)
	clr.b (a2)

	;-----------------------------------;

; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_HSLID
; Asm label   : GWVA_WTEXT_PRG_HSLID
; Description : Ordre de mouvement du slider horizontal
;
; Rq  : 
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 26/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_HSLID:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_HSLID
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_hslid_car_on_hslid_consome

	;-----------------------------------;

	; !! attention  a1 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	load.l a1

	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2	; largeur fentre en caractre

	move GWVA_WTEXT_OBJ_NB_COLONNES(a0),d3	; largeur buffer
	sub d2,d3
	move.w bmsg_slider_percent(a1),d1		; % du GEM
	mulu d3,d1
	divu #1000,d1
	move d1,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)

	bsr GWVA_WTEXT_CALCULATE_CURRENT_PRINT_COLUMN
	; -----
*	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW

*?	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0)
*?	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_COL(a0)
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),GWVA_WTEXT_OBJ_CUR_AFF_COL(a0)

	bsr GWVA_WTEXT_CALCULATE_PHSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	; -----

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_HSLIDED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_HSLIDED

.pas_hslid_car_on_hslid_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_VSLID
; Asm label   : GWVA_WTEXT_PRG_VSLID
; Description : Ordre de mouvement du slider vertical
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 26/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_VSLID:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_VSLID
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_vslid_car_on_vslid_consome

	;-----------------------------------;

	; !! attention  a1 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	load.l a1

	ext.l d3
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d3	; hauteur fentre en caractre

	move GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0),d2	; hauteur buffer
	addq.w #1,d2
	sub d3,d2
	move.w bmsg_slider_percent(a1),d1		; % du GEM
	mulu d2,d1
	divu #1000,d1
	move d1,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)

	bsr GWVA_WTEXT_CALCULATE_CURRENT_PRINT_LINE
	; -----
*	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW

*?	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0)
*?	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_COL(a0)
	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0)

	bsr GWVA_WTEXT_CALCULATE_PVSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	; -----

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_VSLIDED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_VSLIDED

.pas_vslid_car_on_vslid_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_ARROW
; Asm label   : GWVA_WTEXT_PRG_ARROW
; Description : Ordre de mouvement d'un slider
;
; Rq  : Mouvement par page ou d'un lment
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 25/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_ARROW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_ARROW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_arrow_car_on_arrow_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	move.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0),GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
	move.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a0),GWVA_WTEXT_OBJ_AFF_COLONNE(a0)

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	load.l a1
	ext.l d2
	ext.l d3
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2	; nb colonnes  l'cran
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d3	; nb lignes  l'cran

	move.w bmsg_arrowed_action(a1),d4		; action ?

	cmp.w #WA_UPPAGE,d4
	bne.s .pas_page_h
	sub.w d3,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
.pas_page_h:
	cmp.w #WA_DNPAGE,d4
	bne.s .pas_page_b
	add.w d3,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
.pas_page_b:
	cmp.w #WA_UPLINE,d4
	bne.s .pas_ligne_h
	subq.w #1,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
.pas_ligne_h:
	cmp.w #WA_DNLINE,d4
	bne.s .pas_ligne_b
	addq.w #1,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
.pas_ligne_b:
	cmp.w #WA_LFPAGE,d4
	bne.s .pas_page_g
	sub.w d2,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
.pas_page_g:
	cmp.w #WA_RTPAGE,d4
	bne.s .pas_page_d
	add.w d2,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
.pas_page_d:
	cmp.w #WA_LFLINE,d4
	bne.s .pas_col_g
	subq.w #1,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
.pas_col_g:
	cmp.w #WA_RTLINE,d4
	bne.s .pas_col_d
	addq.w #1,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
.pas_col_d:

	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0),d4
	addq.w #1,d4			; numro de ligne
	sub.w d3,d4
	cmp.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),d4	; dpassement de la dernire ligne visible
	bge.s .ok2
	move.w d4,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
.ok2:
	tst.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0)
	bpl.s .ok1
	clr.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0)

.ok1:	move GWVA_WTEXT_OBJ_NB_COLONNES(a0),d4
	sub d2,d4
	cmp.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),d4
	bge.s .ok4
	move.w d4,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
.ok4:
	tst.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
	bpl.s .ok3
	clr.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0)
.ok3:
	bsr GWVA_WTEXT_CALCULATE_CURRENT_PRINT_LINE
	bsr GWVA_WTEXT_CALCULATE_CURRENT_PRINT_COLUMN
	; -----
*	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW

*?	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0)
*?	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a0),GWVA_WTEXT_OBJ_CUR_BUF_COL(a0)

	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),d0
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),d1
	cmp.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0),d0
	bne.s .changement_ligne
	cmp.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a0),d1
	beq.s .pas_changement_colonne
.changement_ligne:

	move.w d0,GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0)
	move.w d1,GWVA_WTEXT_OBJ_CUR_AFF_COL(a0)

	bsr GWVA_WTEXT_CALCULATE_PVSLIDE
	bsr GWVA_WTEXT_CALCULATE_PHSLIDE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

.pas_changement_colonne:
	; -----

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_ARROWED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_ARROWED

.pas_arrow_car_on_arrow_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_CALC_SLIDERS
; Asm label   : GWVA_WTEXT_PRG_CALC_SLIDERS
; Description : Recalcul les taille/positions des sliders de la fentre et les
;	    affichage
;
; Rq  : 
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 25/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_CALC_SLIDERS:
; pas de before

	;-----------------------------------;

; Appel des mthodes de la fentre

	bsr GWVA_WTEXT_CALCULATE_HVSLIDE	; ici il faut forcer le raffichage
	bsr GWVA_WTEXT_CALCULATE_PVSLIDE	; des slides car la fentre peut avoir
	bsr GWVA_WTEXT_CALCULATE_WHSLIDE	; chang de taille
	bsr GWVA_WTEXT_CALCULATE_PHSLIDE

	move.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0),GWVA_WTEXT_OBJ_AFF_LIGNE(a0)	; peut tre problme
	move.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a0),GWVA_WTEXT_OBJ_AFF_COLONNE(a0)	; plus tard

	;-----------------------------------;

; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WTEXT_PRG_WM_REDRAW
; Description : Mthode de redessin d'une partie du contenu de la fentre
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED si le message est pour cette fentre
;	   GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_WM_REDRAW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
	bne .methode_consomme_mais_pas_traitement_par_pere

	;-----------------------------------;

	save.l a1-a2/d0

	movem.w bmsg_xywh(a1),d0-d3

	add.w d0,d2
	subq #1,d2
	add.w d1,d3
	subq #1,d3
	movem.w d0-d3,GWVA_WTEXT_ZONE_CLIPPING_REDRAWING

	save.l a0

	vs_clip #1,d0,d1,d2,d3		; clip on : x1,y1 -> x2,y2

	vswr_mode #MD_REPLACE
	vsf_color #0		; blanc
	bsr GWVA_ROOT_HIDE_MOUSE

	movem.w GWVA_WTEXT_ZONE_CLIPPING_REDRAWING,d0-d3
	v_bar d0,d1,d2,d3		; rectangle blanc pour le fond

	load.l a0

	lea GWVA_WTEXT_ZONE_CLIPPING_REDRAWING,a1
	bsr GWVA_WTEXT_CALC_PARAM_REDRAW_ZONE

	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0),d6
	cmp.w d6,d2
	bgt.s .pas_reaffich		; Est-ce qu'il ya du texte dans la zone  rafficher ?

	bsr GWVA_WTEXT_WRITE_TEXT_IN_WINDOW

.pas_reaffich:
	save.l a0
	bsr GWVA_ROOT_SHOW_MOUSE
	vs_clip #0,#0,#0,#0,#0
	load.l a0

	load.l a1-a2/d0

	;-----------------------------------;
	; envoyer la mthode GWVA_METHOD_WM_REDRAWN

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

	move.w #GWVA_NO_ERROR_GENERIC,d7
.methode_consomme_mais_pas_traitement_par_pere:
.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_SIZE
; Asm label   : GWVA_WTEXT_PRG_SIZE
; Method name : GWVA_METHOD_WM_MOVE
; Asm label   : GWVA_WTEXT_PRG_MOVE
; Description : Dplacement d'une fentre texte avec un ventuel changement de taille
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  dplacer/redimensionner
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_WM_SIZE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_SIZE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_size_car_on_size_consome

	;-----------------------------------;
	; !! attention  a0-a2/d0

	bsr GWVA_WTEXT_PRG_COMMON_SIZE_MOVE
	cmp.w #GWVA_PRGRET_CONSUMED,d6
	bne .methode_non_consommee

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_SIZED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_SIZED

.pas_size_car_on_size_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	;-----------------------------------;

GWVA_WTEXT_PRG_WM_MOVE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_MOVE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_move_car_on_move_consome

	;-----------------------------------;
	; !! attention  a0-a2/d0

	bsr GWVA_WTEXT_PRG_COMMON_SIZE_MOVE
	cmp.w #GWVA_PRGRET_CONSUMED,d6
	bne .methode_non_consommee

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_MOVED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_MOVED

.pas_move_car_on_move_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	;-----------------------------------;

GWVA_WTEXT_PRG_COMMON_SIZE_MOVE:
	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	save.l a0-a2/d0

	; est-ce que on a toujours a1 (dans le cas d'appel direct ...) ?_ERROR_?
	movem.w bmsg_xywh(a1),d0-d3	; x,y,w,h

	save.l a1
	bsr GWVA_WIND_CONVERT_ABSOLUTE_RELATIVE_POS
	bsr GWVA_WIND_CONVERT_EXT_INT_POS_SIZE	; -> d0-d3.w : position/taille interne

	move.w d2,d0
	move.w d3,d1

	lea GWVA_WTEXT_TMP_BUFFER,a1
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES

	movem.w (a1),d2-d3
	bsr GWVA_WIND_CONVERT_INT_EXT_POS_SIZE
	bsr GWVA_WIND_CONVERT_RELATIVE_ABSOLUTE_POS

	load.l a1

	movem.w d2-d3,bmsg_w(a1)

	load.l a0-a2/d0

	;-----------------------------------;

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	;------------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_FULL
; Asm label   : GWVA_WTEXT_PRG_FULL
; Description : demande de Full d'une fentre texte
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  fuller
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 11/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_WM_FULL:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_FULL
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_full_car_on_full_consome

	;-----------------------------------;
	; !! attention  a0-a2/d0

; On ne peut pas appeler en hritage la mthode de la classe WIND, car autrement
; le full ne serait pas correctement gr. En fait, si on clique sur le gadget FULL
; une deuxime fois, la fentre doit reprendre sa position et sa taille prcdente.
; Mais dans notre cas, si on a t oblig de corriger la taille de la fentre aprs le
; full, la position/taille prcdente est perdue par le GEM.

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

	;--------------------;

	save.l d0/a0-a2

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}
	bne.s .full

	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}	; full

	bsr GWVA_WIND_RETURN_MAX_EXT_ABS_POS_SIZE
	bsr GWVA_WIND_REDUCE_EXT_WH_TO_CONTENTS
	; a0 = ptr, sortie : d0/d3 => x,y,w,h max ext

	bra.s .common_end

.full:	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}	; position prcdente

	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_PREVXYWH
	load.l a0

	movem.w int_out+2,d0-d3			; x,y,w,h
	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	beq.s .pas_namifiee2

	add.w GWVA_WIND_OBJ_INT_VISIBLE_H(a0),d3
	add GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3

.pas_namifiee2:

.common_end:
	bsr GWVA_WIND_CONVERT_EXT_INT_POS_SIZE

	sub.w GWVA_WIND_OBJ_INT_BORDERS_W(a0),d2
	sub.w GWVA_WIND_OBJ_INT_BORDERS_H(a0),d3
	; -> d2-d3 : taille du contenu visible

	save.w d0-d1
	lea GWVA_WTEXT_TMP_BUFFER,a1
	move.w d2,d0
	move.w d3,d1
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES
	load.w d0-d1

	movem.w (a1),d2-d3		; taille du contenu visible corrige

	add.w GWVA_WIND_OBJ_INT_BORDERS_W(a0),d2
	add.w GWVA_WIND_OBJ_INT_BORDERS_H(a0),d3

	bsr GWVA_WIND_CONVERT_INT_EXT_POS_SIZE

	bsr GWVA_WIND_CALC_AND_SET_SIZE_WIND

	;--------------------;

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	load.l d0/a0-a2

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_FULLED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_FULLED

.pas_full_car_on_full_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CLOSE
; Asm label   : GWVA_WTEXT_PRG_CLOSE
; Description : Fermeture d'une fentre texte
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : d0.w = handle GEM de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 22/11/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_CLOSE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_CLOSE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_close_car_on_close_consome

	;-----------------------------------;
	; !! attention  a0 et d0

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_classe_mere

	;------------------

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_COPYXY:1}
	beq.s .pas_copy_pos

	; il faut transformer les infos stocks la classe WIND en taille caractre

	movem.w GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0),d0-d1
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1
	ext.l d0
	ext.l d1
	movem.w GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2-d3
	divu d2,d0
	divu d3,d1
	movem.w d0-d1,GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0)

.pas_copy_pos:

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CLOSED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CLOSED

.pas_close_car_on_close_consome
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_non_consommee_par_classe_mere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_OPEN
; Asm label   : GWVA_WTEXT_PRG_OPEN
; Description : Ouverture d'une fentre texte
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; in  : d0.w = handle GEM de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;	   ou erreur OPEN de la classe WIND
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_OPEN:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_OPEN
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_open_car_on_open_consome

	;-----------------------------------;
	; !! attention  a0 et d0

	save.w d0
	movem.w GWVA_WIND_OBJ_INT_VISIBLE_W(a0),d0-d1	; taille interne

	lea GWVA_WIND_OBJ_INT_VISIBLE_W(a0),a1
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES
	load.w d0

	;-------------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .methode_consomme_mais_pas_traitement_par_pere

	;------------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CALC_SLIDERS

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_OPENED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_OPENED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.methode_consomme_mais_pas_traitement_par_pere:
.pas_open_car_on_open_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WTEXT_PRG_DELETE
; Description : Mthode de destruction d'une fentre texte
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_DELETE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	move.l GWVA_WTEXT_OBJ_MALLOC(a0),d0
	beq.s .pas_mfree_malloc
	save.l a0
	MFREE d0
	load.l a0
	clr.l GWVA_WTEXT_OBJ_MALLOC(a0)
.pas_mfree_malloc:

	;-------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	;-----------------------------------;

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WTEXT_PRG_CREATE
; Description : Mthode de cration d'une fentre texte
;
; Rq  : -
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur
;	   GWVA_ERROR_WTEXT_MALLOC
;	   ou erreur cration de la classe WIND
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_CREATE:

	; reset les pointeurs, efface le buffer
	; fait le malloc

	move.w GWVA_WTEXT_OBJ_NB_COLONNES(a0),d0
	mulu GWVA_WTEXT_OBJ_NB_LIGNES(a0),d0
	addq.l #1,d0			; taille du buffer de caractre +0  la fin

	save.l a0
	MXALLOC #MX_PREFTTRAM,d0
	load.l a0
	tst.l d0
	beq.s .error_alloc_memory

	move.l d0,GWVA_WTEXT_OBJ_MALLOC(a0)
	
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WTEXT_CLEAR_BUFFER

	bsr GWVA_WTEXT_CREATE_CONTENTS_SIZES

	;-------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_creation

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.error_alloc_memory:
	move #GWVA_ERROR_WTEXT_MALLOC,d7
.pas_creation:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES
; Asm label   : GWVA_WTEXT_PRG_CORRECT_VISIBLE_SIZES
; Description : Mthode pour corriger la taille visible de la fentre texte
;	    (remise  une taille multiple d'un caractre)
;
; Rq  : Pas de ON ni de ED
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur o stocker width.w->0(a1) et height.w->2(a1)
; in  : d0.w = largeur avant correction
; in  : d1.w = hauteur avant correction
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_PRG_CORRECT_VISIBLE_SIZES:
; On corrige la taille visible en nombre entier de caractres

	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1

	ext.l d0
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d0	; nombre entier de caracs
	mulu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d0

	ext.l d1
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d1
	mulu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d1

	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1

	movem.w d0-d1,(a1)

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WTEXT_CREATE_CONTENTS_SIZES
; Description : Dtermine la taille de la fentre
;
; Rq  : Renseigne les champs GWVA_WIND_OBJ_CONTENTS_W/H
; Rq  : Transforme la taille visible d'ouverture de caractre  pixel
;
; in  : a0.l = pointeur sur la fentre
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CREATE_CONTENTS_SIZES:

	save.l a0
	vst_height GWVA_WTEXT_OBJ_FNT_SIZE(a0)	; pour rcuprer le tableau en sortie
	load.l a0
	move.w ptsout+1*2,GWVA_WTEXT_OBJ_FNT_SIZE(a0)
	move.w ptsout+2*2,GWVA_WTEXT_OBJ_CELL_WIDTH(a0)
	move.w ptsout+3*2,GWVA_WTEXT_OBJ_CELL_HEIGHT(a0)

	movem.w GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2-d3

	movem.w GWVA_WTEXT_OBJ_NB_COLONNES(a0),d4-d5
	mulu d2,d4
	mulu d3,d5
	movem.w d4-d5,GWVA_WIND_OBJ_CONTENTS_W(a0)

	movem.w GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0),d4-d5
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,d4
	beq.s .pas_d_init_w
	mulu d2,d4
	move.w d4,GWVA_WIND_OBJ_INT_VISIBLE_W(a0)
.pas_d_init_w:
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,d5
	beq.s .pas_d_init_h
	mulu d3,d5
	move.w d5,GWVA_WIND_OBJ_INT_VISIBLE_H(a0)
.pas_d_init_h:

	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WTEXT_CALC_PARAM_REDRAW_ZONE
; Description : Calcul la zone  rafficher d'une fentre texte
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur un buffer contenant la zone  redessiner x1,y1,x2,y2
; out : d0-d1.w = x,y du dbut du raffichage du texte
; out : d2-d3.w = ligne,colonne du buffer o commence le raffichage
; out : d4-d5.w = nombre de ligne,colonne  rafficher
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALC_PARAM_REDRAW_ZONE:

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE	; -> d0-d3
	load.l a1
; d0-d1 position visible du contenu
	move.w d0,d4
	move.w d1,d5

	movem.w (a1),d2-d3	; x1,y1 clipping

	sub.w d0,d2
	sub.w d1,d3		; position du clipping/contenu
	ext.l d2
	ext.l d3
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d3
	muls GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2
	muls GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d3	; d2-d3 multiple d'un caractre
	add.w d2,d0
	add.w d3,d1

	movem.w d0-d1,(a1)	; x1,y1 du clipping  un multiple de caractre

	move.w d1,d2		; y1 clipping
	sub.w d5,d2			; position du rectangle de clipping
	ext.l d2 			; par rapport au contenu de la fentre
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d2
	add.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),d2	; num de la ligne  afficher

	move.w d0,d3		; x1 clipping
	sub.w d4,d3			; position du rectangle de clipping
	ext.l d3			; par rapport au contenu de la fentre
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d3
	add.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),d3	; num de la colone  afficher

	move.w 4(a1),d5		; x2
	sub.w (a1),d5		
	addq.w #1,d5		; width
	ext.l d5
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d5
	moveq #0,d6
	swap d5
	tst.w d5
	beq.s .caractere_entier
	moveq #1,d6
.caractere_entier:
	swap d5
	add.w d6,d5			; d5 = nb de colonne  afficher

	move.w 6(a1),d4		; y2
	sub.w 2(a1),d4
	addq.w #1,d4		; height
	ext.l d4
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d4
	moveq #0,d6
	swap d4
	tst d4
	beq.s .caractere_entier2
	moveq #1,d6
.caractere_entier2:
	swap d4
	add.w d6,d4			; d4 = nb de ligne  afficher

	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WTEXT_WRITE_TEXT_IN_WINDOW
; Description : Affiche une partie du buffer texte dans la fentre.
;
; in  : a0.l = pointeur sur la fentre
; in  : d0-d1.w = x,y du dbut du raffichage du texte
; in  : d2-d3.w = ligne,colonne du buffer o commence le raffichage
; in  : d4-d5.w = nombre de ligne,colonne  rafficher
; in  : d6.w = limite texte : cur_buf_lign ou buf_ligne
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_WRITE_TEXT_IN_WINDOW:
	save.l d0-d6/a0
	vst_height GWVA_WTEXT_OBJ_FNT_SIZE(a0)
	vst_alignment #0,#5	; aligne  gauche et en haut
	vst_color #1	; noir
	load.l d0-d6/a0

.affiche_texte:

	move.l GWVA_WTEXT_OBJ_MALLOC(a0),a6	; ad du texte
	move.w d2,d7
	mulu GWVA_WTEXT_OBJ_NB_COLONNES(a0),d7
	add.l d7,a6
	add.w d3,a6		; pointe le dbut du texte  afficher

	save.w d0-d6

.affiche_suite_ligne:

	move.w d5,d2	; nbre de caractre  afficher sur cette ligne
	cmp.w #127-1,d2	; on limite  la taille du tableau intin (et le 0.b final)
	ble.s .longueur_ligne_inf127
	moveq #127-1,d2
.longueur_ligne_inf127:
	sub.w d2,d5		; d5.w : nombre de caractre restant  afficher sur la ligne

	move.b (a6,d2.w),-(sp)

	clr.b (a6,d2.w)	; normalement on tombe toujours dans le buffer ... ?

	save.l d0-d2/d5/a0/a6
	v_gtext d0,d1,a6
	load.l d0-d2/d5/a0/a6

	move.b (sp)+,(a6,d2.w)

	lea (a6,d2.w),a6
	mulu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2
	add.w d2,d0			; on passe  la suite de la ligne

	tst.w d5
	bne.s .affiche_suite_ligne

	load.w d0-d6

	add.w GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d1
	addq #1,d2
	cmp.w d6,d2
	bgt.s .out_buffer		; fin du texte dans le buffer ?
	subq #1,d4			; fin fentre ?
	bne.s .affiche_texte
.out_buffer:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WTEXT_CALCULATE_PHSLIDE
; Description : Calcul la position du curseur colonne d'affichage, ainsi que
; Description : la position ventuelle d'un slider horizontal et l'affiche.
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 22/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALCULATE_PHSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	; d2.w : largeur visible du contenu de la fentre

	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2	; nb colonnes  l'cran

	move GWVA_WTEXT_OBJ_NB_COLONNES(a0),d0	; nb de colonne maximale de la page
	move.w d0,d1
	sub.w d2,d1				; indice max de la 1er colonne affiche

	cmp.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a0),d1
	ble.s .min
	move.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a0),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WTEXT_OBJ_CUR_AFF_COL(a0)	; d1.w : indice de la premire ligne affiche

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_HSLIDER

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WTEXT_CALCULATE_WHSLIDE
; Description : Calcul la taille du slider horizontal et l'affiche
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 22/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALCULATE_WHSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE

	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2	; nb colonnes visible
	move.w GWVA_WTEXT_OBJ_NB_COLONNES(a0),d0	; nb de colonne max

	move.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a0),d1	; indice de la premire ligne affiche

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_HSLIDER
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WTEXT_CALCULATE_PVSLIDE
; Description : Calcul la position du curseur ligne d'affichage, ainsi que
; Description : la position ventuelle d'un slider vertical et l'affiche.
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALCULATE_PVSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	move.w d3,d2	; taille vertical visible du contenu de la fentre

	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d2	; nb lignes pouvant tre affiches dans la fentre
					; de 1  n
	move GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0),d0
	addq.w #1,d0			; hauteur totale de la page

	move.w d0,d1
	sub.w d2,d1		; d1 = indice max de la 1er ligne affiche

	cmp.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0),d1	; on rectifie CUR_AFF_LIGN
	ble.s .min
	move.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0)	; d1.w : indice de la premire ligne affiche

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_VSLIDER

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WTEXT_CALCULATE_HVSLIDE
; Description : Calcul la taille du slider vertical, et l'affiche.
;
; in  : a0.l = pointeur sur l'objet fentre
;
; 22/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALCULATE_HVSLIDE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	move.w d3,d2	; d2.w : taille vertical visible du contenu de la fentre

	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d2	; hauteur en caractre du contenu visible
	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a0),d0
	addq.w #1,d0			; hauteur en caractre de la page entire

	move.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a0),d1	; indice de la premire ligne affiche

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_SET_VSLIDER

	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WTEXT_CALCULATE_CURRENT_PRINT_LINE
; Description : Calcule la position du curseur ligne d'affichage courant.
;
; in  : a0.l = pointeur sur la fentre
;
; 21/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALCULATE_CURRENT_PRINT_LINE:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	; d3.w -> hauteur visible du contenu

	ext.l d3
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a0),d3	; nb lignes pouvant tre affiches dans la fentre
					; de 1  n
	move GWVA_WTEXT_OBJ_BUF_LIGNE(a0),d1	; position du curseur ligne
	addq.w #1,d1
	sub.w d3,d1				; d1 = numro de 1er ligne de la fentre
	cmp.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),d1	; on rectifie
	ble.s .min
	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a0),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WTEXT_OBJ_AFF_LIGNE(a0)

	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WTEXT_CALCULATE_CURRENT_PRINT_COLUMN
; Description : Calcule la position du curseur colonne d'affichage courant.
;
; in  : a0.l = pointeur sur la fentre
;
; 25/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WTEXT_CALCULATE_CURRENT_PRINT_COLUMN:
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	; d2.w : largeur visible du contenu

	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a0),d2	; nb colonnes  l'cran

	move GWVA_WTEXT_OBJ_NB_COLONNES(a0),d1
	sub.w d2,d1
	move.w d1,d3
	cmp.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),d1
	ble.s .min
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a0),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WTEXT_OBJ_AFF_COLONNE(a0)

	rts

;------------------------------------------------------------------------------

 BSS

GWVA_WTEXT_ZONE_CLIPPING_REDRAWING:	ds.w 4
GWVA_WTEXT_TMP_BUFFER:		ds.w 2
GWVA_WTEXT_MSG_BUF:		ds.w 8

 TEXT
