	ifeq 1

	ifd ...

GWVA_COLOR_CONVERT_FALCON_RGB_TO_VDI:	; ne modifie que D0,D1,D2
; Entre :	d0.l : couleur au format xRGB.l
; Sortie :	d0.w : Rouge en pour mille (VDI)
;	d1.w : Vert en pour mille (VDI)
;	d2.w : Bleu en pour mille (VDI)

	move.b d0,d2	; Bleu
	ext.w d2
	mulu #1000,d2
	divu #255,d2	; bleu VDI	0 -> 1000

	lsr.l #8,d0
	move.b d0,d1	; Vert
	ext.w d1
	mulu #1000,d1
	divu #255,d1	; Vert VDI	0 -> 1000

	lsr.l #8,d0		; rouge
	ext.w d0
	mulu #1000,d0
	divu #255,d0	; Vert VDI	0 -> 1000

	rts

	endc
		*----------------------*
	ifd ...

GWVA_COLOR_CONVERT_TT_RGB_TO_VDI:		; ne modifie que D0,D1,D2
; Entre :	d0.w : couleur au format TT (bits R:11-8 V:7-4 B:3-0)
; Sortie :	d0.w : Rouge en pour mille (VDI)
;	d1.w : Vert en pour mille (VDI)
;	d2.w : Bleu en pour mille (VDI)

	move.b d0,d2
	and.b #%00001111,d2	; Bleu
	ext.w d2
	mulu #1000,d2
	divu #15,d2		; bleu VDI	0 -> 1000

	lsr.w #4,d0
	move.b d0,d1
	and.b #%00001111,d1	; Vert
	ext.w d1
	mulu #1000,d1
	divu #15,d1		; Vert VDI	0 -> 1000

	lsr.w #4,d0
	and.b #%00001111,d0	; rouge
	ext.w d0
	mulu #1000,d0
	divu #15,d0		; Vert VDI	0 -> 1000

	rts

	endc
		*----------------------*
	ifd ...

GWVA_COLOR_CONVERT_STE_RGB_TO_VDI:		; ne modifie que D0,D1,D2
; Entre :	d0.w : couleur au format STE (identique TT mais les bit de poids faible sont en premier : 0321)
; Sortie :	d0.w : Rouge en pour mille (VDI)
;	d1.w : Vert en pour mille (VDI)
;	d2.w : Bleu en pour mille (VDI)

	move.b d0,d2
	and.b #%00001111,d2	; Bleu
	lsl.b #1,d2
	bclr #4,d2
	beq.s .bit_4_0a
	bset #0,d2
.bit_4_0a:
	ext.w d2
	mulu #1000,d2
	divu #15,d2		; bleu VDI	0 -> 1000

	lsr.w #4,d0
	move.b d0,d1
	and.b #%00001111,d1	; Vert
	lsl.b #1,d1
	bclr #4,d1
	beq.s .bit_4_0b
	bset #0,d1
.bit_4_0b:
	ext.w d1
	mulu #1000,d1
	divu #15,d1		; Vert VDI	0 -> 1000

	lsr.w #4,d0
	and.b #%00001111,d0	; rouge
	lsl.b #1,d0
	bclr #4,d0
	beq.s .bit_4_0c
	bset #0,d0
.bit_4_0c:
	ext.w d0
	mulu #1000,d0
	divu #15,d0		; Vert VDI	0 -> 1000

	rts

	endc
		*----------------------*
	ifd ...

GWVA_COLOR_CONVERT_ST_RGB_TO_VDI:		; ne modifie que D0,D1,D2
; Entre :	d0.w : couleur au format ST
; Sortie :	d0.w : Rouge en pour mille (VDI)
;	d1.w : Vert en pour mille (VDI)
;	d2.w : Bleu en pour mille (VDI)

	move.b d0,d2
	and.b #%00000111,d2	; Bleu
	ext.w d2
	mulu #1000,d2
	divu #7,d2		; bleu VDI	0 -> 1000

	lsr.w #4,d0
	move.b d0,d1
	and.b #%00000111,d1	; Vert
	ext.w d1
	mulu #1000,d1
	divu #7,d1		; Vert VDI	0 -> 1000

	lsr.w #4,d0
	and.b #%00000111,d0	; rouge
	ext.w d0
	mulu #1000,d0
	divu #7,d0		; Vert VDI	0 -> 1000

	rts

	endc

*******************************************************

	move.l (GWVA_WBITM_OBJ_PAL_PTR,[GWVA_WIND_OBJ_SPEC_PTR,a0]),d0
	beq.s .pas_de_palette

	moveq #1,d1		; est-on dans une rsolution avec palette ?
	move.w GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,d2
	lsl.w d2,d1

	move.l (GWVA_WBITM_OBJ_PAL_PTR,[GWVA_WIND_OBJ_SPEC_PTR,a0]),d0
	beq.s .pas_de_palette

	move.w GWVA_APP_OBJ_VDI_WORKSTATION+13*2,d3
	cmp.w d3,d1
	bne.s .pas_resolution_palette

	btst #BIT_COMPATIBILITE,...(bit fenetre[GWVA_WIND_OBJ_SPEC_PTR,a0])
	beq.s .palette_xbios

.pas_resolution_palette:

	lea .table_conversion_1plan_vdi,a1

	cmp.w #2,d1
	beq.s .color_2
	lea .table_conversion_2plan_vdi,a1
	cmp.w #4,d1
	beq.s .color_4
	lea .table_conversion_4plan_vdi,a1
	cmp.w #16,d1
	beq.s .color_16
	lea .table_conversion_8plan_vdi,a1
*	cmp.w #256,d1
*	beq.s .color_256
.color_2:
.color_4:
.color_16:
*.color_256:
	sub.w #1,d3		; nombre de pinceaux
	move.l d0,a2	; palette
	move.w (bit fenetre[GWVA_WIND_OBJ_SPEC_PTR,a0]),d4
	and.w #mask type palette,d4

.convert_palette_vdi:

	ifd ...
	cmp.w #FALCON,d4	; quel type de palette
	bne.s .....
	move.l (a2)+,d0	; palette falcon
	bsr GWVA_COLOR_CONVERT_FALCON_RGB_TO_VDI
	endc

	ifd ...
	cmp.w #TT,d4
	bne.s .....
	move.w (a2)+,d0	; palette tt
	bsr GWVA_COLOR_CONVERT_TT_RGB_TO_VDI
	endc

	ifd ...
	cmp.w #STE,d4
	bne.s .....
	move.w (a2)+,d0	; palette ste
	bsr GWVA_COLOR_CONVERT_STE_RGB_TO_VDI
	endc

	ifd ...
	cmp.w #ST,d4
	bne.s .....
	move.w (a2)+,d0	; palette st
	bsr GWVA_COLOR_CONVERT_ST_RGB_TO_VDI
	endc

	clr.w d5
	move.b (a1)+,d5	; index VDI correspondant
	save.l d3-d4/a0-a2
	vs_color d5,d0,d1,d2
	load.l d3-d4/a0-a2

	dbf d3,.convert_palette_vdi

	......

.palette_xbios:

; Problme des cookies : on besoin du cookie de la vido _VDO

	save.l a0

	cmp.w #$2,GWVA_APP_OBJ_COOKIE_VIDEO
	bne.s .pas_video_TT

	move.l d0,-(sp)	; palette
	move.w d1,-(sp)	; nombre de couleurs
	clr.w -(sp)
	appel xbios,$54,10
	bra.s .palette_TT_set
.pas_video_TT:

	cmp.w #$3,GWVA_APP_OBJ_COOKIE_VIDEO
	bne.s .pas_video_Falcon

	move.l d0,-(sp)	; palette
	move.w d1,-(sp)	; nombre de couleurs
	clr.w -(sp)
	appel xbios,$5d,10
	bra.s .palette_Falcon_set
.pas_video_Falcon:

; en dernier on fait du st

	move.l d0,-(sp)	; palette
	appel xbios,$06,6

.palette_Falcon_set:
.palette_TT_set:
	load.l a0

	.....

.table_conversion_1plan_vdi:	dc.b 0,1
.table_conversion_2plan_vdi:	dc.b 0,2,3,1
.table_conversion_4plan_vdi:	dc.b 0,2,3,6,4,7,5,8,9,10,11,14,12,15,13,1
.table_conversion_8plan_vdi:	dc.b 0,2,3,6,4,7,5,8,9,10,11,14,12,15,13,255
GWVA_COUNT_COLOR set 16
			rept 256-16
			dc.b GWVA_COUNT_COLOR
GWVA_COUNT_COLOR set GWVA_COUNT_COLOR+1
			endr

			dc.b 1

	endc	; ifeq 1