
;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_CHECK_MENU
; Description : check/uncheck un objet d'un menu
; 
; in  : a0.l = pointeur sur le tree du menu
; in  : d0.w = index de l'objet
; in  : d1.w = 0 : uncheck, 1 : check
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_CHECK_MENU: 	; Passe dans a0.l l'adresse de l'objet MENU
	menu_icheck a0,d0,d1	; d0 : numro du menu, d1 : 0=effacer,1=afficher
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_GREY_MENU
; Description : grey/ungrey un objet d'un menu
; 
; in  : a0.l = pointeur sur le tree du menu
; in  : d0.w = index de l'objet
; in  : d1.w = 0 : grey, 1 : ungrey
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_GREY_MENU: 	; Passe dans a0.l l'adresse de l'objet MENU
	menu_ienable a0,d0,d1	; d0 : numro du menu, d1 : 0=disable,1=enable
	rts

