
	ifd LIB_STRING_CHANGE_CASE
;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_STRING_PUT_IN_UPPERCASE_0
; Description : Change le case en majuscule jusqu'au 1er 0.b
; Asm label   : GWVA_STRING_PUT_IN_UPPERCASE
; Description : Change le case en majuscule jusqu' une valeur donne
; 
; in  : a0.l = pointeur sur la chaine (termin par 0.b pour GWVA_STRING_PUT_IN_UPPERCASE_0)
; in  : d0.w = identifiant de fin de chaine (pour GWVA_STRING_PUT_IN_UPPERCASE)
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_STRING_PUT_IN_UPPERCASE_0:
	clr.b d0
GWVA_STRING_PUT_IN_UPPERCASE:
	clr d1
.next:	move.b (a0)+,d1
	cmp.b d0,d1
	beq.s .fin
	cmp.w #'a',d1
	blt.s .next
	cmp.w #'z',d1
	bgt.s .next
	sub.b #'a'-'A',d1
	move.b d1,-1(a0)
	bra.s .next

.fin:	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_STRING_PUT_IN_LOWERCASE_0
; Description : Change le case en minuscule jusqu'au 1er 0.b
; Asm label   : GWVA_STRING_PUT_IN_LOWERCASE
; Description : Change le case en minuscule jusqu' une valeur donne
; 
; in  : a0.l = pointeur sur la chaine (termin par 0.b pour GWVA_STRING_PUT_IN_LOWERCASE_0)
; in  : d0.w = identifiant de fin de chaine (pour GWVA_STRING_PUT_IN_LOWERCASE)
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_STRING_PUT_IN_LOWERCASE_0:
	clr.b d0
GWVA_STRING_PUT_IN_LOWERCASE:
	clr d1
.next:	move.b (a0)+,d1
	cmp.b d0,d1
	beq.s .fin
	cmp.w #'A',d1
	blt.s .next
	cmp.w #'Z',d1
	bgt.s .next
	add.b #'a'-'A',d1
	move.b d1,-1(a0)
	bra.s .next

.fin:	rts

	endc	; ifd LIB_STRING_CHANGE_CASE
