;************************************************
;* Usage ****************************************
; in .DEF
;GWVA_WSP_CTE_WORKSPACE = $1000		
;GWVA_WSP_CTE_TYPICAL_NB_BLOC =100	; optionnel
;
; in .S
;	move.l	#100,d0
;	bsr	GWVA_WSP_NEW_BLOC		; reserve one bloc large enough for 100 bytes
;	...
;	bsr	GWVA_WSP_BLOC_MAX_SIZE_INQUIRE	; ask for the largest bloc possible
;	...
;	move.l	#100,d0
;	bsr	GWVA_WSP_NEW_BLOC		; reserve more blocs
;
;	bsr	GWVA_WSP_MORE_WORKSPACE		; alloc more workspaces
;	...
;	bsr	GWVA_WSP_SHRINK_BLOC		; can shrink blocs whenever you want
;	...
;	bsr	GWVA_WSP_FREE_BLOC		; can free blocs whenever you want
;	...
;
;************************************************

; Propositions

;1- Renomer la fonction WSP_NEW_WORKSPACE pour la notion de 'new' -> enlever la notion de WORKSPACE
;   Ok: _MORE_
;2- La taille du WSP est dfini dans le DEF par un GWVA_WSP_CTE_...= taille par dfaut des WSP
;   Ok.
;3- -> plus que des blocs
;   Ok.
;4! Cration automatique des WPS si plus de place dans le WSP courant
;   Non:c'est un espace de travail rserv (comme le bss). Ce n'est pas un malloc ; l'extensibilit n'est pas son but.
;5- Vrifier que les WPS sont aligns sur des long
;   Ok, mais sans doute redondant avec malloc.

