	output d:\assemble\visual42\samples\start\start.app

*OPT_GWVA_DEBUG_PRINT_COMMENTS
OPT_GWVA_DEBUG_ERROR

OPT_FULL_PATHNAMES	; pour avoir le chemin complet du ressource pendant le dbug
*OPT_GWVA_DEBUG_VISUAL_SYSTEM_EVNT
*OPT_GWVA_DEBUG_VISUAL_WIND_OBJ_EVNT
*OPT_GWVA_DEBUG_VISUAL_FORM_OBJ_EVNT
*OPT_DEBUG_IN_ACCESSORY_MODE
MDL_FORM_EDITABLE_TEXT
PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT
MDL_CHILDREN_WINDOWS
MDL_WIND_TOOLBAR
*MDL_RELOCATE_RSC


	lea objet_application,a1

	include start.def
	include visual42.s
	include start.hs
	include start.obj

	comment HEAD=7
	section TEXT

*--------------------------------------------------------------------------*
	; Ceci est le programme de rfrence pour le Visual Assembleur 4.2
	; Il utilise presque toutes les fonctionnalits de base (pas les librairies)
	; C'est celui que les concepteurs du V.A testent en premier quand ils
	; intgrent une nouvelle fonctionalit.

*GWVA_FORM_WIND_OBJECT_CUSTOM1=$0100
*my_inits:	move.l #my_custom_objects_processing,GWVA_WFORM_OBJ_CUSTOM_OBJ_PRG

my_inits_created:
	ifd OPT_DEBUG_IN_ACCESSORY_MODE
	bra.s .acc
	endc	; ifd OPT_DEBUG_IN_ACCESSORY_MODE

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc

	bfset objet_application+GWVA_WAPP_OBJ_PROPERTIES{GWVA_WAPP_OLBIT_BACKGROUND:1}	; fond
	bfset objet_application+GWVA_WIND_OBJ_PROPERTIES{GWVA_WIND_OLBIT_AMENU:1}	; menu
	rts

.acc:	bfset objet_fenetre_fond+GWVA_WIND_OBJ_PROPERTIES{GWVA_WIND_OLBIT_AMENU:1}	; menu dans la fenetre
	rts

my_inits_opened:
	ifd OPT_DEBUG_IN_ACCESSORY_MODE
	bra.s acc_open
	endc	; ifd OPT_DEBUG_IN_ACCESSORY_MODE

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc
	
	lea objet_fenetre5,a0
*	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND

	move #CAUTION,d0
	move #3,d1
	bsr RSC_ALERT_BOX

.acc:	rts

		*--------------------------*

menu_modal:	move.w #FORMULAIRE3,d0
	bsr GWVA_PRG_MODAL_FORM
	rts

		*--------------------------*

acc_open:	lea texte,a0		; 35 chars max.
	lea mask,a1			; 18 caracteres max
	lea 0,a2			; pas de slection par dfaut
	bsr FILE_SELECTOR
	tst d0
	ble.s .annule		; annule ou erreur ?

	move #ALERT1,d0		; exemple d'alerte dans le ressource
	move #2,d1
	bsr RSC_ALERT_BOX

	lea objet_fenetre_fond,a0	; on ouvre la fenetre avec le menu
*	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND

.annule:	rts

		*--------------------------*

app_term:
menu_quit:
acc_close:
	tst GWVA_ROOT_IS_ACC_PRG
	bne VISUAL_END

	rts

		*--------------------------*

	; On peut recevoir des messages particuliers

va_start_message:
	rts

		*--------------------------*
menu_wind1:
	; Attention cette fentre a TOPABLE_STATE = 1
	; elle est donc untopable : jamais en premier plan !
	; quand on l'ouvre : elle se met derrire (untop) toute seule!

	lea objet_fenetre1,a0
*	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	rts

	; REMARQUE GENERALE : optimisation, on peut remplacer 
	; un BSR label suivi d'un RTS par un BRA
	; c'est moins lisible ... a vous de voir

		*--------------------------*

menu_wind9:	lea objet_fenetre8,a0
	bsr GWVA_WIND_OBJ_PRG_TEST_IF_WIND_CREATED
	tst d7
	bpl.s .no

	lea image2,a0
	move #RAM_TT_ST,d0		; TT de prfrence sinon ST
	bsr LOAD_FILE_IN_MEM
	tst.l d0
	ble.s .no

	; Image TRUE-COLOR (65536 couleurs)
	; on charge un fichier avec l'image au format cran en premier
	; taille : 320*240 * 16 bits
	; pas de palette !

	move.l a0,a2
	lea objet_fenetre8,a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move #320,GWVA_WBITM_OBJ_IMG_WIDTH(a1)
	move #240,GWVA_WBITM_OBJ_IMG_HEIGHT(a1)
	move.l a2,GWVA_WBITM_OBJ_DATA_PTR(a1)
	move #16,GWVA_WBITM_OBJ_NBR_BITPLANES(a1)
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	lea objet_fenetre8,a0
	tst d7
	bmi.s event_window_bitmap_closed

.no:	rts

		*--------------------------*

menu_wind8:	lea objet_fenetre9,a0
	bsr GWVA_WIND_OBJ_PRG_TEST_IF_WIND_CREATED
	tst d7
	bpl.s .no

	lea image3,a0
	move #RAM_TT_ST,d0		; TT de prfrence sinon ST
	bsr LOAD_FILE_IN_MEM
	tst.l d0
	ble.s .no

	; Image 256 couleurs
	; on charge un fichier avec l'image au format cran en premier
	; taille : 320*240 * 8 bits
	; puis la palette : 256 couleurs = 256*32 bits

	move.l a0,a2
	lea objet_fenetre9,a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move #320,GWVA_WBITM_OBJ_IMG_WIDTH(a1)
	move #240,GWVA_WBITM_OBJ_IMG_HEIGHT(a1)
	move.l a2,GWVA_WBITM_OBJ_DATA_PTR(a1)
	add.l #320*240,a2
	move.l a2,GWVA_WBITM_OBJ_PAL_PTR(a1)
	move #8,GWVA_WBITM_OBJ_NBR_BITPLANES(a1)
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	lea objet_fenetre9,a0
	tst d7
	bmi.s event_window_bitmap_closed

.no:	rts

		*--------------------------*

menu_wind10:
	; Cette fenetre est une fenetre compose de 4 filles

	lea objet_fenetre10,a0
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	rts

		*--------------------------*

event_window6_arrowed:
	; exemple de message pas trs intressant mais bon ... c'est possible

	rts

		*--------------------------*

my_custom_objects_processing:
	rts

		*--------------------------*

	section DATA

wind_icon1:	incbin winicon1.raw
wind_icon2:	incbin winicon2.raw

texte:	dc.b 'Genuwax for the best : ',0

	ifnd OPT_FULL_PATHNAMES
image2:	dc.b 'start32k.raw',0
	else
image2:	dc.b 'd:\assemble\visual41\samples\start\start32k.raw',0
	endc

	ifnd OPT_FULL_PATHNAMES
image3:	dc.b 'start256.raw',0
	else
image3:	dc.b 'd:\assemble\visual41\samples\start\start256.raw',0
	endc

mask:	dc.b '*.S,*.BAK',0
 even

 END
