update_stik_wind_infos:

	move.l STIK_TPL_POINTER,a0
	move.l STIK_TPL_module(a0),a0
	save.l a0
	move #FORM_STIK_INFO,d0
	move #TXT_MODULE,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.w ([a0,ob_spec],te_txtlen),d0		; longueur du texte
	load.l a0
	subq #2,d0				; moins le 0 et dbf
.recopy1:	move.b (a0)+,(a1)+
	dbf d0,.recopy1

	move.l STIK_TPL_POINTER,a0
	move.l STIK_TPL_author(a0),a0
	save.l a0
	move #FORM_STIK_INFO,d0
	move #TXT_AUTHOR,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.w ([a0,ob_spec],te_txtlen),d0		; longueur du texte
	load.l a0
	subq #2,d0				; moins le 0 et dbf
.recopy2:	move.b (a0)+,(a1)+
	dbf d0,.recopy2

	move.l STIK_TPL_POINTER,a0
	move.l STIK_TPL_version(a0),a0
	save.l a0
	move #FORM_STIK_INFO,d0
	move #TXT_VERSION,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.w ([a0,ob_spec],te_txtlen),d0		; longueur du texte
	load.l a0
	subq #2,d0				; moins le 0 et dbf
.recopy3:	move.b (a0)+,(a1)+
	dbf d0,.recopy3

	moveq #0,d0				; total
	jsr STIK_PRG_KRgetfree
	save.l d0
	move #FORM_STIK_INFO,d0
	move #TXT_TOT_AVAILMEM,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	load.l d0
	bsr GWVA_STOCK_DECI

	moveq #-1,d0			; largest
	jsr STIK_PRG_KRgetfree
	save.l d0
	move #FORM_STIK_INFO,d0
	move #TXT_BIGGEST_MEMB,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	load.l d0
	bsr GWVA_STOCK_DECI

	jsr STIK_PRG_carrier_detect
	save.l d0
	move #FORM_STIK_INFO,d0
	move #TXT_CARRIER_DTCT,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	load.l d0
	cmp.w #1,d0
	bne.s .pas_carrier
	move.l #'yes'*256,(a1)
	bra.s .end_carrier_detect
.pas_carrier:
	tst d0
	bmi.s .no_carrier
.unknown:	move.l #'???'*256,(a1)
	bra.s .end_carrier_detect
.no_carrier:move.l #'no'*65536,(a1)
.end_carrier_detect:

	move last_error_for_info_window,d0
	jsr STIK_PRG_get_err_text
	save.l d0
	move #FORM_STIK_INFO,d0
	move #TXT_LAST_ERROR,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.w ([a0,ob_spec],te_txtlen),d0		; longueur du texte
	load.l a0
	subq #2,d0				; moins le 0 et dbf
.recopy4:	move.b (a0)+,(a1)+
	dbf d0,.recopy4

			***** Partie ditable ******

	move.l STIK_STIK_CONFIG,a0
	move.l STIK_CONFIG_client_ip(a0),d0
	save.l d0
	move #FORM_STIK_INFO,d0
	move #ETXT_CLIENT_IP,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	load.l d0
	moveq #32,d1
	bsr GWVA_STOCK_HEXA

	move.l STIK_STIK_CONFIG,a0
	move.l STIK_CONFIG_provider(a0),d0
	save.l d0
	move #FORM_STIK_INFO,d0
	move #ETXT_PROVIDER_IP,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	load.l d0
	moveq #32,d1
	bsr GWVA_STOCK_HEXA

	move #STIK_CONFIG_ttl,d0
	move #ETXT_TTL,d1
	bsr .stok_deci

	move #STIK_CONFIG_ping_ttl,d0
	move #ETXT_PING_TTL,d1
	bsr .stok_deci

	move #STIK_CONFIG_mtu,d0
	move #ETXT_MTU,d1
	bsr .stok_deci

	move #STIK_CONFIG_mss,d0
	move #ETXT_MSS,d1
	bsr .stok_deci

	move #STIK_CONFIG_df_bufsize,d0
	move #ETXT_DF_BUFSIZE,d1
	bsr .stok_deci

	move #STIK_CONFIG_rcv_window,d0
	move #ETXT_RCV_WIN,d1
	bsr .stok_deci

	move #STIK_CONFIG_def_rtt,d0
	move #ETXT_DEF_RTT,d1
	bsr .stok_deci

	move #STIK_CONFIG_time_wait_time,d0
	move #ETXT_WAIT_TIME,d1
	bsr .stok_deci

	rts

.stok_deci:	move.l STIK_STIK_CONFIG,a0
	move.w 0(a0,d0.w),d0
	and.l #$ffff,d0
	save.l d0
	move #FORM_STIK_INFO,d0
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	load.l d0
	bsr GWVA_STOCK_DECI
	rts
			******************
wind_stik_info_apply_new_params:
	move #FORM_STIK_INFO,d0
	move #ETXT_CLIENT_IP,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a0
	clr.b d0
	bsr GWVA_HEXA2VALUE
	tst d7
	bmi.s .erreur_conv1
	move.l STIK_STIK_CONFIG,a0
	move.l d1,STIK_CONFIG_client_ip(a0)
.erreur_conv1:

	move #FORM_STIK_INFO,d0
	move #ETXT_PROVIDER_IP,d1
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a0
	clr.b d0
	bsr GWVA_HEXA2VALUE
	tst d7
	bmi.s .erreur_conv2
	move.l STIK_STIK_CONFIG,a0
	move.l d1,STIK_CONFIG_provider(a0)
.erreur_conv2:

	move #STIK_CONFIG_ttl,d0
	move #ETXT_TTL,d1
	bsr .update_deci

	move #STIK_CONFIG_ping_ttl,d0
	move #ETXT_PING_TTL,d1
	bsr .update_deci

	move #STIK_CONFIG_mtu,d0
	move #ETXT_MTU,d1
	bsr .update_deci

	move #STIK_CONFIG_mss,d0
	move #ETXT_MSS,d1
	bsr .update_deci

	move #STIK_CONFIG_df_bufsize,d0
	move #ETXT_DF_BUFSIZE,d1
	bsr .update_deci

	move #STIK_CONFIG_rcv_window,d0
	move #ETXT_RCV_WIN,d1
	bsr .update_deci

	move #STIK_CONFIG_def_rtt,d0
	move #ETXT_DEF_RTT,d1
	bsr .update_deci

	move #STIK_CONFIG_time_wait_time,d0
	move #ETXT_WAIT_TIME,d1
	bsr .update_deci

	rts

.update_deci:
	save.w d0
	move #FORM_STIK_INFO,d0
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a0
	clr.b d0
	bsr GWVA_DECI2VALUE
	load.w d0
	tst d7
	bmi.s .bad_conv3
	move.l STIK_STIK_CONFIG,a0
	move.w d1,(a0,d0.w)
.bad_conv3:
	rts

 BSS
last_error_for_info_window:	ds.w 1
 TEXT
