	DATA

GWVA_FCLICK_EQUIV_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_CLICK,GWVA_FCLICK_EQUIV_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_CLICK
; Asm label   : GWVA_FCLICK_EQUIV_PRG_CLICK
; Description : Mthode de traitement d'un clic sur un radio bouton
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer d'entre typ GWVA_FORM_CLICK_IN
; in  : d0.l = [ X.w | num gem.w ]
; in  : d1.l = [ Y.w | mouse button.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 05/04/98 : Cration
;------------------------------------------------------------------------------
GWVA_FCLICK_EQUIV_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_FORM_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_click_car_on_click_consomme

	;-----------------------------------;

	cmp.w GWVA_FCLICK_EQUIV_OBJ_MAIN_IDX(a0),d0
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0-d2/a0-a1
	objc_offset GWVA_FORM_CLICK_IN_TREE_PTR(a1),GWVA_FCLICK_EQUIV_OBJ_TARGET_IDX(a0)
	load.l d0-d2/a0-a1

	swap d1	; car les interfaces sont comme a ...

	move.w int_out+2,d0	; NE PAS FAIRE DE MOVEM.W car il yu a extension
	move.w int_out+4,d1	; du signe et on perd le mot haut !!!

	; il faudrait faire un appl_tplay pour etre parfaitement beau
	move.l GWVA_ROOT_CLICK_OBJ_PTR,a0	; oh c'est pas beau !!!
*	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),a0

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_CLICK

	;-----------------------------------;

.pas_click_car_on_click_consomme:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts
