	DATA

GWVA_FRADIO_BUTTON_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_CLICK,GWVA_FRADIO_BUTTON_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_CLICK
; Asm label   : GWVA_FRADIO_BUTTON_PRG_CLICK
; Description : Mthode de traitement d'un clic sur un radio bouton
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer d'entre typ GWVA_FORM_CLICK_IN
; in  : d0.l = [ X.w | num gem.w ]
; in  : d1.l = [ Y.w | mouse button.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 04/04/98 : Cration
;------------------------------------------------------------------------------

GWVA_FRADIO_BUTTON_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_FORM_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_click_car_on_click_consomme	; je ne suis pas concern

	;-----------------------------------;

	move.w GWVA_FORM_CLICK_IN_FATHER_IDX(a1),d7
	cmp.w GWVA_FRADIO_OBJ_FATHER_IDX(a0),d7
	bne .ce_n_est_pas_mon_pere

	lea FRADIO_TMP_IN_BUF,a3
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),GWVA_FORM_BUTTON_IN_WIND_PTR(a3)
	move.l GWVA_FORM_CLICK_IN_TREE_PTR(a1),GWVA_FORM_BUTTON_IN_TREE_PTR(a3)

	save.l a1			; seul ce paramtre bouge
	move.l a3,a1
	lea FRADIO_TMP_OUT_BUF,a2
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_FORM_BUTTON
	load.l a1			; seul ce paramtre bouge

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne.s .clic_non_traite

; les infos dans le buffer de retour sont donc valides

	;-----------------------------------;

	; mettre changed ...

*	tst GWVA_FORM_BUTTON_OUT_RET_CODE(a2)	; pour un radio : on s'en moque bien
*	bne .propriete_exit_non_activee		; car ils sont rarement exit

	move.w GWVA_FORM_BUTTON_OUT_OBJECT(a2),d0
	cmp.w GWVA_FRADIO_OBJ_SELECTION(a0),d0
	beq.s .selection_inchangee

	; Attention : positionner les paramtres d'entre + sauver les courants
	; ! on ne prpare pas les paramtres comme il faut pour le moment !

	swap d0
	move.w GWVA_FORM_BUTTON_OUT_NEW_TYPE(a2),d0
	swap d0

	move.w GWVA_FRADIO_OBJ_SELECTION(a0),d1
	mulu #L_OBJECT,d1
	move.l GWVA_FORM_CLICK_IN_TREE_PTR(a1),a3
	add.l d1,a3
	move.w ob_type(a3),d1
	swap d1
	move.w GWVA_FRADIO_OBJ_SELECTION(a0),d1	; avant de l'craser

	move.w GWVA_FORM_BUTTON_OUT_OLD_STATE(a2),d2
	swap d2

	move.w d0,GWVA_FRADIO_OBJ_SELECTION(a0)	; nouvelle
	move.l GWVA_FORM_CLICK_IN_TREE_PTR(a1),a2	; tant que a1 est bon
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),a1

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_CHANGED

.selection_inchangee:

.clic_non_traite:
.pas_click_car_on_click_consomme:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.ce_n_est_pas_mon_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

 BSS
FRADIO_TMP_IN_BUF:	ds.b GWVA_FORM_BUTTON_IN_STRUCT_LENGTH
FRADIO_TMP_OUT_BUF:	ds.b GWVA_FORM_BUTTON_OUT_STRUCT_LENGTH
 TEXT
