	DATA

GWVA_WFORM_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_WFORM_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_WFORM_PRG_DELETE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_REDRAW,GWVA_WFORM_PRG_WM_REDRAW
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_KEYPRESS,GWVA_WFORM_PRG_KEYPRESS	; commune quand pas de wind mais menu
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_CLICK,GWVA_WFORM_PRG_CLICK

	ifd MDL_FORM_EDITABLE_TEXT
	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_UNTOP,GWVA_WFORM_PRG_UNTOP
	endc	; ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	endc	; ifd MDL_FORM_EDITABLE_TEXT

	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

	ifd MDL_FORM_EDITABLE_TEXT
	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_UNTOP
; Asm label   : GWVA_WFORM_PRG_UNTOP
; Description : Mthode ragissant au message WM_UNTOPPED
;
; in  : a0   = pointeur sur l'objet fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  untopper
; 
; 22/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_UNTOP:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_UNTOP
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_untop_car_on_untop_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,GWVA_WFORM_OBJ_FOCUSED_IDX(a0)
	beq.s .no_ed_txt

	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}	; plus de curseur texte

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS
.no_ed_txt:

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_WM_ONTOPPED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_UNTOPPED

.pas_untop_car_on_untop_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	;-----------------------------------;

	endc	; ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	endc	; ifd MDL_FORM_EDITABLE_TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_CLICK
; Asm label   : GWVA_WFORM_PRG_CLICK
; Description : Gestion du clic dans une fentre avec des objets formulaires
;
; Rq  : Redistribution aux objets formulaires de la fentres
;
; in  : a0.l = pointeur sur l'objet fentre
; in  : d0.l = [ X.w | handle fentre gem.w ]
; in  : d1.l = [ mouse button.w | Y.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED si le click est pour la fentre
;	   ou GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_CLICK_IS_CONSUMED : le clic a t consomm par la fentre
; 	   GWVA_WRSC_CTE_CLICK_IS_NOT_CONSUMED : clic pas dans un objet GEM RSC
;	   GWVA_WFORM_CTE_CLICK_IS_CONSUMED : clic dans un objet FORM V.A.
;	   GWVA_WFORM_CTE_CLICK_IS_NOT_CONSUMED : clic dans un objet RSC mais pas dans un objet FORM V.A.
;
; 10/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_CLICK:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WIND_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_wform_click_car_on_wform_click_consome

	;-----------------------------------;

	; appeler la mthode de la fentre WRSC
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_WRSC_CTE_CLICK_IS_CONSUMED,d7
	bne .click_pas_dans_RSC

	;--------------------

	save.l d0
	lea GWVA_WFORM_TMP_BUFFER,a1
	swap d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WRSC_IDX_UNDER_XY
	load.l d0

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .object_under_xy
	illegal
.object_under_xy:

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2

	move.w (a1)+,d3	; idx
	move.w (a1)+,d4	; father idx

	move.w d3,d5	; idx de l'objet click
	mulu #L_OBJECT,d5

	; on teste si je suis pas slectable mais que mon pre le serait
	; et dans ce cas on fait comme si il avait cliqu dans mon pre

	btst #SELECTABLE,ob_flags+1(a2,d5.l)
	bne.s .je_suis_selectable

	move.w d4,d5	; idx du pre de l'objet click
	mulu #L_OBJECT,d5

	btst #SELECTABLE,ob_flags+1(a2,d5.l)
	beq.s .mon_pere_n_est_pas_selectable

	move d4,d3		; l'objet cliqu devient le pre : 
			; ruse pour les caractres "shortcut" sur les boutons
	save.l d0-d3/a0-a1
	move.l a2,a0	; a0.l tree
	move d3,d0		; d0.w num obj
	bsr GWVA_RSC_FIND_FATHER_OBJECT
	move d0,d4		; pre
	load.l d0-d3/a0-a1
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .pere_existe
	clr d4		; c'est qu'on tait obj 0 : pas de pre
.pere_existe:

.mon_pere_n_est_pas_selectable:
.je_suis_selectable:

	save.l d0/d1	; c'est les seuls qui soient scratchs en fait
	move d3,d0		; d0= X / Idx RSC
	swap d1		; d1= Y / mouse button
	lea GWVA_FORM_CLICK_IN_STRUCT,a1
	move d4,GWVA_FORM_CLICK_IN_FATHER_IDX(a1)
	move.l a0,GWVA_FORM_CLICK_IN_WIND_PTR(a1)
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),GWVA_FORM_CLICK_IN_TREE_PTR(a1)
	GWVA_CALL_METHOD4	#GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,#GWVA_METHOD_FORM_CLICK
	load.l d0/d1

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED_BY_ONE_OBJECT,d6
	bne.s .fclic_non_consomme

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WIND_CLICKED

	move.w #GWVA_WFORM_CTE_CLICK_IS_CONSUMED,d7
.pas_wform_click_car_on_wform_click_consome:
	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts
.fclic_non_consomme:
	move.w #GWVA_WFORM_CTE_CLICK_IS_NOT_CONSUMED,d7
.click_pas_dans_RSC
	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_KEYPRESS
; Asm label   : GWVA_WFORM_PRG_KEYPRESS
; Description : Mthode de gestion des vnements claviers pour les
; Description : fentres formulaires
;
; Rq  : Renvoie si la touche a t consomme ou pas
;
; in  : a0.l = pointeur sur l'objet
; in  : d0.w = Key code
; in  : d1.w = Key state
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; 
; 25/07/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_KEYPRESS:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_KEYPRESS
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_keypress_car_on_keypress_consome

	;-----------------------------------;

	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .methode_consommee_par_pere
	cmp.w #GWVA_SEARCH_EXEC_NOT_CONSUMED,d6
	bne.w .keypress_pas_traite

	;-----------------------------------;

; Mise  jour du ressource

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WRSC_UPDATE

	;-----------------------------------;

	; Ne sert  rien vu que cette mthode n'existe pas pour ces objets,
	; mais permet d'activer un sortcut sur une mthode s'il y en a un
	; d0+d1  jour
	GWVA_CALL_METHOD4	#GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,#GWVA_METHOD_KEYPRESS
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED_BY_ONE_OBJECT,d6
	beq.w .shortcut_a_consomme_la_touche

	;-----------------------------------;

	save.w d0

	move.w d1,d2
	swap d2
	move.w d0,d2	; d2.w = [ Key state.w | Key code.w ]

	move.w GWVA_WFORM_OBJ_FOCUSED_IDX(a0),d0

	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,d0
	bne.s .champ_editable_defini

	; Recherche du bouton DEFAULT quand il n'y pas de champ de texte ditable

	move.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,GWVA_WFORM_TMP_DEFAULT_OBJECT

	save.l d1-d2/a0

	save.l a0

	move.w GWVA_WRSC_OBJ_IDX(a0),d0
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_RSC_FIND_FATHER_OBJECT
	move.w d0,d1

	move.l (sp),a0
	
	move.w GWVA_WRSC_OBJ_IDX(a0),d0
	lea GWVA_WFORM_TEST_DEFAULT_FLAG,a1
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	move.l a0,a2
	move.w d0,d2
	mulu #L_OBJECT,d2
	add.l d2,a2
	bsr GWVA_RSC_GO_OVER_TREE

	load.l a0

	load.l d1-d2/a0

	move.w GWVA_WFORM_TMP_DEFAULT_OBJECT,d0

	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,d0
	beq.s .pas_objet_default

.champ_editable_defini:
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0),d1

	; a1 = ptr fenetre contenant le formulaire
	move.l a0,a1
	; a2=ptr form
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2

	GWVA_CALL_METHOD4 #GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,#GWVA_METHOD_FORM_KEYPRESS

.pas_objet_default:

	load.w d0

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_KEYPRESSED

.shortcut_a_consomme_la_touche:
.pas_keypress_car_on_keypress_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.keypress_pas_traite:
.methode_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts


GWVA_WFORM_TEST_DEFAULT_FLAG:
	move.w #GWVA_RSC_CTE_CONTINUE_GO_OVER,d7
	btst #DEFAULT,ob_flags+1(a2)
	beq.s .pas_default
	move.w d0,GWVA_WFORM_TMP_DEFAULT_OBJECT
	move.w #GWVA_RSC_CTE_STOP_GO_OVER,d7
.pas_default:
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WFORM_PRG_WM_REDRAW
; Description : Mthode de redessin d'une partie d'une fentre formulaire
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED si le message est pour cette fentre
;	   GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_REDRAW_IS_POSSIBLE
; 	   GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE
;
; 21/06/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_WM_REDRAW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

	;-----------------------------------;
	; Effacage du curseur texte

	ifd MDL_FORM_EDITABLE_TEXT

	ifd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	cmp.l #0,a2		; si a2=0 le curseur sera effac par le redraw
	beq.s .redraw_all_objects	; donc inutile

	save.l d0/a0-a2

	movem.w bmsg_xywh(a1),d0-d3
	add.w d0,d2
	add.w d1,d3
	sub.w #1,d2
	sub.w #1,d3
	vs_clip #1,d0,d1,d2,d3

	movem.l (sp),d0/a0-a2
	bsr GWVA_WFORM_HIDE_CURSOR

	vs_clip #0,#0,#0,#0,#0

	load.l d0/a0-a2

.redraw_all_objects:

	endc	; ifd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	endc	; ifd MDL_FORM_EDITABLE_TEXT

	;-----------------------------------;

	; appeler la mthode de la fentre RSC
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere	; provoque erreur si la mthode n'existe pas !!!

	cmp.w #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
	bne .methode_consomme_mais_pas_traitement_par_pere

	;-----------------------------------;

	; Affichage du curseur texte

	ifd MDL_FORM_EDITABLE_TEXT

	ifd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	save.l d0/a0-a2

	movem.w bmsg_xywh(a1),d0-d3
	add.w d0,d2
	add.w d1,d3
	sub.w #1,d2
	sub.w #1,d3
	vs_clip #1,d0,d1,d2,d3

	movem.l (sp),d0/a0-a2
	bsr GWVA_WFORM_REDRAW_CURSOR

	vs_clip #0,#0,#0,#0,#0

	load.l d0/a0-a2

	endc	; ifd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	endc	; ifd MDL_FORM_EDITABLE_TEXT

	;-----------------------------------;
	; envoyer la mthode GWVA_METHOD_WM_REDRAWN

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

	move.w #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_consomme_mais_pas_traitement_par_pere:
	move.w #GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE,d7
.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	ifeq 1

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX
; Asm label   : GWVA_WFORM_PRG_REDRAW_CONTENTS_BOX
; Description : Mthode de redessin d'une partie d'une fentre formulaire
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = x
; in  : d1.w = y
; in  : d2.l = [ width.w | height.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 12/02/98 : Cration
; 14/06/98 : Modification pour l'appel de la mthode de la classe RSC
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_REDRAW_CONTENTS_BOX:

	GWVA_CALL_METHOD	#GWVA_METHOD_ON_WIND_REDRAW_CONTENTS_BOX,#GWVA_MODE_SEARCH_EXEC_LOCAL_ONLY
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; appeler la mthode de la fentre RSC
	GWVA_CALL_METHODNTEST2	#GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX,#GWVA_MODE_EXEC_METHOD_ENCAPSULATED_CLASS

	;-----------------------------------;

	; ------------------ AFFICHAGE DU CURSEUR TEXTE ---------------------

	ifd MDL_FORM_EDITABLE_TEXT2
; A REVOIR
	save.l d0-d3/a0-a2

	graf_mouse #M_OFF

	movem.l (sp),d0-d3/a0-a2

	move.w d2,d3
	swap d2

	ifd PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT

	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	vs_clip #1,d0,d1,d2,d3

	movem.l (sp),a0-a2
	bsr GWVA_WIND_OBJ_PRG_REDRAW_ED_TXT_CURSOR

	vs_clip #0,#0,#0,#0,#0

	endc	; ifd PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT

	graf_mouse #M_ON
	load.l d0-d3/a0-a2

	endc	; ifd MDL_FORM_EDITABLE_TEXT

	;-----------

	;-----------------------------------;
	; envoyer la mthode GWVA_METHOD_WIND_CONTENTS_BOX_REDRAWN

	GWVA_CALL_METHOD	#GWVA_METHOD_WIND_CONTENTS_BOX_REDRAWN,#GWVA_MODE_SEARCH_EXEC_LOCAL_ONLY

.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	endc	; ifeq 1

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WFORM_PRG_DELETE
; Description : Mthode de destruction du contenu d'une fentre formulaire
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 01/02/98 : Cration
; 14/06/98 : Modification pour l'appel de la mthode de la classe RSC
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_DELETE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	bsr GWVA_ROOT_DELETE_ALL_FIRST_SONS

	;-----------------------------------;

	bftst GWVA_WFORM_OBJ_PROPERTIES(a0){GWVA_WFORM_OLBIT_COPY_FOCUS:1}
	beq.s .no_copy_current_focus_to_first
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX(a0),GWVA_WFORM_OBJ_FIRST_FOCUSED_IDX(a0)
.no_copy_current_focus_to_first:

	;-------------

	; appeler la mthode de la fentre RSC
	GWVA_CALL_METHOD_INHERITED

	;-----------------------------------;

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WFORM_PRG_CREATE
; Description : Mthode de cration du contenu d'une fentre formulaire
;
; Rq  : Appel la mthode CREATE de la classe RSC.
; Rq  : Initialise l'objet focus.
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   erreur de la mthode CREATE de la classe WRSC
;
; 01/02/98 : Cration
; 14/06/98 : Modification pour l'appel de la mthode de la classe RSC
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_CREATE:

	; appeler la mthode de la fentre RSC
	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_creation

	;-----------------------------------;

	move.l a0,a1
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2
	bsr GWVA_ROOT_CREATE_ALL_FIRST_SONS
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur_creation_fils

	;-----------------------------------;

	ifd MDL_FORM_EDITABLE_TEXT2

;  on initialise la position du curseur en fonction du premier champ ditable

	move.w GWVA_WFORM_OBJ_FIRST_FOCUSED_IDX(a0),d1
	move.w d1,GWVA_WFORM_OBJ_FOCUSED_IDX(a0)
	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,d1
	beq.s .no_editable_txt
	save.l a0
	move.w GWVA_WRSC_OBJ_TREE(a1),d0
	bsr GWVA_RSC_COUNT_TEXT_OBJ_LENGTH	; <- d0,d1, -> d0,d1
	load.l a0
	move.w d0,GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0)
	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}
.no_editable_txt:
	endc	; ifd MDL_FORM_EDITABLE_TEXT

	;-------------

	move.w GWVA_WFORM_OBJ_FIRST_FOCUSED_IDX(a0),GWVA_WFORM_OBJ_FOCUSED_IDX(a0)

	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,GWVA_WFORM_OBJ_FIRST_FOCUSED_IDX(a0)
	beq.s .il_n_y_aura_jamais_rien_d_edite
*	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_1ST_FOUND,GWVA_WFORM_OBJ_FIRST_FOCUSED_IDX(a0)
*	bne.s .pas_valeur_speciale_on_continue
*	; Il faudrait chercher le premier champ ditable en parcourant tout l'arbre
*	; et mettre GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF si aucun trouv
*	illegal
*	bra.s .pas_de_champ_editable	; temporaire
*.pas_valeur_speciale_on_continue:

	move.w GWVA_WRSC_OBJ_TREE(a0),d0
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX(a0),d1
	save.l a0
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a0
	bsr GWVA_COUNT_BYTES_0
	load.l a0
	move.w d0,GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0)
.pas_de_champ_editable:
.il_n_y_aura_jamais_rien_d_edite:

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7

.erreur_creation_fils:
.erreur_creation:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
 BSS
	; pour appeler le form click depuis le wind_click
GWVA_FORM_CLICK_IN_STRUCT:	ds.b GWVA_FORM_CLICK_IN_STRUCT_LENGTH

GWVA_WFORM_TMP_BUFFER:	ds.w 2
GWVA_WFORM_TMP_DEFAULT_OBJECT:	ds.w 1

 TEXT