	DATA

GWVA_WIND_DEFAULT_METHODLIST:
	ifd MDL_WIND

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS,GWVA_WIND_PRG_REDRAW_ALL_CONTENTS
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_REDRAW_PART_CONTENTS,GWVA_WIND_PRG_REDRAW_PART_CONTENTS

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_WIND_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_WIND_PRG_DELETE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CLOSE,GWVA_WIND_PRG_CLOSE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_OPEN,GWVA_WIND_PRG_OPEN

*	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_GEM_CREATE,GWVA_WIND_PRG_CREATE_ONE_GEM_WIND

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_UNTOP,GWVA_WIND_PRG_UNTOP
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_ONTOP,GWVA_WIND_PRG_ONTOP
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_TOP,GWVA_WIND_PRG_TOP
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_NEWTOP,GWVA_WIND_PRG_NEWTOP
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_MOVE,GWVA_WIND_PRG_MOVE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_SIZE,GWVA_WIND_PRG_SIZE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_FULL,GWVA_WIND_PRG_FULL
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_REDRAW,GWVA_WIND_PRG_WM_REDRAW
	ifd MDL_WIND_ICONIFICATION
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_ICONIFY,GWVA_WIND_PRG_ICONIFY
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_UNICONIFY,GWVA_WIND_PRG_UNICONIFY
	endc	; ifd MDL_WIND_ICONIFICATION

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_CLICK,GWVA_WIND_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_SET_VSLIDER,GWVA_WIND_PRG_SET_VSLIDER
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_SET_HSLIDER,GWVA_WIND_PRG_SET_HSLIDER
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_NAMIFY_UNAMIFY,GWVA_WIND_PRG_NAMIFY_UNAMIFY
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY,GWVA_WIND_PRG_MOVE_SLIDERS_WITH_KEY
	endc	; ifd MDL_WIND

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_KEYPRESS,GWVA_WIND_PRG_KEYPRESS	; commune quand pas de wind mais menu

	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_KEYPRESS
; Asm label   : GWVA_WIND_PRG_KEYPRESS
; Description : Mthode de base de la gestion des vnements claviers pour les
; Description : fentres
;
; Rq  : Cherche dans le menu puis test les shortcuts du fils focus puis lui
; Rq  : distribut la touche.
; Rq  : Renvoie si la touche a t consomme ou pas
;
; in  : a0.l = pointeur sur l'objet
; in  : d0.w = Key code
; in  : d1.w = Key state
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; 
; 25/01/98 : Cration
; 14/02/98 : passage de WAPP  WIND : on est presque totalement transparent mcaniquement
; 25/07/98 : Support de la surcharge et du test des shortcuts
;------------------------------------------------------------------------------
its_a_key:
GWVA_WIND_PRG_KEYPRESS:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_KEYPRESS
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_keypress_car_on_keypress_consome

	;-----------------------------------;

	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .methode_consommee_par_classe_mere

	;----------------

; Une window namifie puis iconifie peut recevoir des evenements si son contenu s'y prte

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	bne.w .fenetre_namifiee

; Il est necessaire de mettre a jour (position...) le formulaire et la toolbar
; ventuels. Bien que ce ne soit pas necessaire dans le cas d'une touche de
; dplacement pour les fentres textes et bitmap, on place l'appel  cet endroit
; pour plus de maintenabilit.

	ifd MDL_WIND
	save.w d0-d1
	bsr GWVA_WIND_UPDATE_MENU_AND_FORM
	load.w d0-d1
	endc	; ifd MDL_WIND

	;----------------

	ifd MDL_MENU

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
	bra.s .fichier_objet_inconsistant
.ptr_menu_non_nul:

	save.l d0-d1/a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_KEYPRESS
	load.l d0-d1/a0

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .menu_has_consumed_key

.fichier_objet_inconsistant:
.no_menu:
	endc	; ifd MDL_MENU

	;----------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .slider_has_consumed_key

	;----------------

; Si focused_child = 0, l'objet est le destinataire de la touche

	tst.l GWVA_WIND_OBJ_FOCUSED_CHILD_PTR(a0)
	beq.s .i_am_the_focused_child

; Sinon on appelle le KEYPRESS de l'objet focus suivant

	save.l a0
	move.l GWVA_WIND_OBJ_FOCUSED_CHILD_PTR(a0),a0
	; Pour cette mthode KEYPRESS, un check des shortcuts de l'objet a lieu
	; automatiquement dans le SEARCH_EXEC juste avant.
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_KEYPRESS
	load.l a0

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .focused_child_has_consumed_key

	bra.s .key_pas_consomme_par_le_focused_child

.i_am_the_focused_child:
	;-----------------------------------;

; L'objet est le destinataire final de la touche : le traitement doit tre fait
; en fonction de la classe hritante (surcharge) ...

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_KEYPRESSED

.key_pas_consomme_par_le_focused_child:
.fenetre_namifiee:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

.focused_child_has_consumed_key:
.slider_has_consumed_key:
.menu_has_consumed_key:

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_KEYPRESSED

.methode_consommee_par_classe_mere:
.pas_keypress_car_on_keypress_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------

	;!!!!!!!!!!!!!!!!!!!!!

	ifd MDL_WIND

	;!!!!!!!!!!!!!!!!!!!!!

	ifd MDL_WIND_ICONIFICATION

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_ICONIFY
; Asm label   : GWVA_WIND_PRG_ICONIFY
; Description : Mthode ragissant au message WM_ICONIFY
;
; in  : a0   = pointeur sur l'objet fentre non iconifie
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  iconifier
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; 
; 28/04/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_ICONIFY:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_ICONIFY
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_iconify_car_on_iconify_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

; a0 pointe sur la structure de la fenetre NON iconifie !

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}	; iconifie ?
	bne.w .window_already_inconified

	save.l a0-a2/d0

	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a1	; a1.l = ptr sur l'objet correspondant  la fentre iconifie

	ifd OPT_GWVA_DEBUG_ERROR

	cmp.l #0,a1
	bne.s .pas_ptr_icon_wind_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_ICON_PTR_NULL
	load.l a0-a2/d0
	bra .iconified_window_not_defined
.pas_ptr_icon_wind_nul:

	endc	; ifd OPT_GWVA_DEBUG_ERROR

	; si au moment de l'iconification je suis focus, alors vu que je garde
	; le mme HANDLE GEM je serai encore focus une fois iconifi

	cmp.l (GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[GWVA_OBJ_FATHER_PTR,a0]),a0
	bne.s .je_ne_suis_pas_focusee
	move.l a1,(GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[GWVA_OBJ_FATHER_PTR,a0])
.je_ne_suis_pas_focusee:

	bsr GWVA_ROOT_CHANGE_OBJECT_IN_TREE
	load.l a0-a2/d0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.w .erreur_arborescence

; Attention au pb pendant le 1er move de la fentre une fois iconifie
; => on vrifiera si taille correcte

	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a3	; a3.l = ptr sur l'objet correspondant  la fentre iconifie
	move.l a0,GWVA_WIND_OBJ_ICON_WIND_PTR(a3)	; on stocke dans la fentre iconifi un pointeur sur la fentre non-iconifie

	bfset GWVA_WIND_OBJ_STATUS(a3){GWVA_WIND_OLBIT_ICON:1}	; on indique que cet objet reprsente une fentre iconifie

	save.l d0/a0-a2
; Le programmeur n'a pas le choix ni de la 1st-position ni de la 1st-taille
; dans le cas de l'iconification
	movem.w bmsg_xywh(a1),d0-d3	; x,y,w,h externe de l'icone dsir
	move.l a3,a0
	bsr GWVA_WIND_CONVERT_ABSOLUTE_RELATIVE_POS
	movem.w d0-d1,GWVA_WIND_OBJ_FIRST_EXT_DX(a0)	; pour le create plus loin
	bsr GWVA_WIND_CONVERT_EXT_INT_POS_SIZE	; ext -> int
	movem.w d2-d3,GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0)	; pour le create
	movem.w d2-d3,GWVA_WIND_OBJ_FIRST_CONTENTS_W(a0)	; pour le create

	bsr GWVA_ROOT_CREATE_OBJECT

	load.l d0/a0-a2

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.w .erreur_creation			; plus de mem ou handle ?

	save.l a0-a2/d0
	
	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a3	; ptr sur la structure de la fentre iconifie
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),GWVA_WIND_OBJ_GEM_HANDLE(a3)
	move.l a3,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN
	load.l d0/a0-a2

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur_open

	save.l d0/a0-a2

	movem.w bmsg_xywh(a1),d0-d3	; x,y,w,h externe de l'icone dsir
	movem.w d0-d3,int_in+4
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_ICONIFY

	movem.l (sp),d0/a0-a2

	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a0
	bsr GWVA_WIND_UPDATE_WIND_TITLE

	ifd MDL_COLORS
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	endc	; ifd MDL_COLORS

	load.l d0/a0-a2

	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}	; plus de curseur texte
	endc

	;-----------------------------------;

	; L'objet n'est plus dans l'arbre et n'existe plus : on ne peut plus activer de mthode
*	; envoyer la mthode GWVA_METHOD_WM_ICONIFIED
*
*	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_ICONIFIED

.pas_iconify_car_on_iconify_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.erreur_open:
	save.l a0
	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE
	load.l a0
.erreur_creation:

; On se replace dans l'arborescence : la fentre iconifi a t totalement enleve par le DELETE

	move.l GWVA_ROOT_PTR_WAPP,a1
	move.l a1,GWVA_OBJ_FATHER_PTR(a0)

	lea GWVA_OBJ_FIRST_SON_PTR(a1),a1
.trouver_derniere_soeur:
	tst.l (a1)
	beq.s .je_suis_la_premiere_fille

	lea (GWVA_OBJ_NEXT_BROTHER_PTR,[a1]),a1
	bra.s .trouver_derniere_soeur
.je_suis_la_premiere_fille:
	move.l a0,(a1)

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
	
.window_already_inconified:
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_ICONIFY_IMPOSSIBLE

.erreur_arborescence:
.iconified_window_not_defined:
.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_UNICONIFY
; Asm label   : GWVA_WIND_PRG_UNICONIFY
; Description : Mthode ragissant au message WM_UNICONIFY
;
; in  : a0   = pointeur sur l'objet fentre iconifie
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  ds-iconifier
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; 
; 28/04/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_UNICONIFY:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_UNICONIFY
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_uniconify_car_on_uniconify_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

; a0 pointe sur la structure de la fenetre iconifie

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}	; iconifie ?
	beq.w .window_not_inconified

	save.l d0/a0-a2

	; si au moment de la dsiconification si je suis focus, alors vu que je garde
	; le mme HANDLE GEM je serai encore focus une fois dsiconifi

	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a3	; pointeur sur la fentre non-iconifie
	cmp.l (GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[GWVA_OBJ_FATHER_PTR,a0]),a0
	bne.s .je_ne_suis_pas_focusee
	move.l a3,(GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[GWVA_OBJ_FATHER_PTR,a0])
.je_ne_suis_pas_focusee:

	movem.w bmsg_xywh(a1),d0-d3	; x,y,w,h
	movem.w d0-d3,int_in+4
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_UNICONIFY

	movem.l (sp),d0/a0-a2

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE	; qui fait un close

	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a3	; pointeur sur la fentre non-iconifie

	bfclr GWVA_WIND_OBJ_STATUS(a3){GWVA_WIND_OLBIT_FULL:1}

	move.l a3,a0
	bsr GWVA_WIND_UPDATE_WIND_TITLE

	movem.l (sp),d0/a0-a2

	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a1	; pointeur sur la fentre non-iconifie

	; On se replace dans l'arborescence : la fentre iconifie
	; a t totalement enleve par le DELETE

	move.l GWVA_ROOT_PTR_WAPP,a2
	move.l a2,GWVA_OBJ_FATHER_PTR(a1)		; pre = WAPP

	; on s'insre en tete : sinon on va se dsiconifier une deuxieme fois
	; de par le parsing qui prend le next brother a chaque fois (et mmorise)
	move.l GWVA_OBJ_FIRST_SON_PTR(a2),a3
	move.l a1,GWVA_OBJ_FIRST_SON_PTR(a2)
	move.l a3,GWVA_OBJ_NEXT_BROTHER_PTR(a1)

*	lea GWVA_OBJ_FIRST_SON_PTR(a2),a2
*.trouver_derniere_soeur:
*	tst.l (a2)
*	beq.s .pas_de_next_brother
*
*	lea (GWVA_OBJ_NEXT_BROTHER_PTR,[a2]),a2
*	bra.s .trouver_derniere_soeur
*.pas_de_next_brother:
*	move.l a1,(a2)
*	clr.l GWVA_OBJ_NEXT_BROTHER_PTR(a1)		; pas de next brother

	ifd MDL_COLORS
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	endc	; ifd MDL_COLORS

	load.l d0/a0-a2

	;-----------------------------------;

*	; envoyer la mthode GWVA_METHOD_WM_UNICONIFIED
*
*	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_UNICONIFIED

.pas_uniconify_car_on_uniconify_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.window_not_inconified:
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_UNICONIFY_IMPOSSIBLE

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	endc	; ifd MDL_WIND_ICONIFICATION

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_UNTOP
; Asm label   : GWVA_WIND_PRG_UNTOP
; Description : Mthode ragissant au message WM_UNTOPPED
;
; in  : a0   = pointeur sur l'objet fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  untopper
; 
; 15/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_UNTOP:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_UNTOP
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_untop_car_on_untop_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	cmp.w #GWVA_CLASS_WIND.APP,(GWVA_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	bne.s .pas_untop_pour_fenetre_fille

	ifd MDL_COLORS
	save.l a0
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	load.l a0
	endc	; ifd MDL_COLORS

	tst GWVA_WIND_OBJ_TOPABLE_STATE(a0)		; untoppable ?
	bge.s .detoppable

	save.l a0
	bsr GWVA_WIND_RETURN_TOP_WINDOW
	load.l a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .the_top_windows_is_not_mine

	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a1
	move.w #WM_TOPPED,bmsg_msgid(a1)
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),bmsg_handle(a1)
	moveq #16,d0		; longueur du message
	move.w #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	save.l a0
	move.l a1,a0
	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	load.l a0

.the_top_windows_is_not_mine:
.detoppable:
.pas_untop_pour_fenetre_fille:

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_ONTOPPED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_UNTOPPED

.pas_untop_car_on_untop_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_ONTOP
; Asm label   : GWVA_WIND_PRG_ONTOP
; Description : Mthode ragissant au message WM_ONTOP
;
; in  : a0   = pointeur sur l'objet fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  topper
; 
; 15/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_ONTOP:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_ONTOP
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_ontop_car_on_ontop_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	cmp.w #GWVA_CLASS_WIND.APP,(GWVA_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	bne.w .pas_ontop_pour_fenetre_fille

	; On peut recevoir un ONTOP alors que la fentre n'est plus TOP : BUG menu-popup.
	; En effet, si une fentre a t ouverte puis referme devant, le ONTOP
	; est tout de mme envoy. On doit donc tester si la fentre est encore TOP

	save.w d0
	bsr GWVA_WIND_RETURN_TOP_WINDOW	; -> d0 et a0
	move.w d0,d1
	load.w d0

	cmp.w d0,d1
	bne.s .fenetre_plus_top

	movem.l (sp),d0/a0-a2

	tst GWVA_WIND_OBJ_TOPABLE_STATE(a0)		; untoppable ?
	ble.s .toppable

; On doit trouver une autre fentre toppable

; Une autre solution au problme des fentres untopables :
;	save.l a0
;	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_BOTTOM
;	load.l a0

	move.l GWVA_ROOT_PTR_WAPP,a1
	move.l GWVA_OBJ_FIRST_SON_PTR(a1),a1
	cmp.l #0,a1
	beq.s .pas_de_fenetre

.cherche_fenetre_toppable:
	cmp.l a0,a1
	beq.s .pas_moi
	bftst GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_OPEN:1}	; est-elle ouverte ?
	beq.s .closed
	tst GWVA_WIND_OBJ_TOPABLE_STATE(a1)		; est-elle un_untoppable ?
	ble.s .there_is_one_toppable
.closed:
.pas_moi:
	move.l GWVA_OBJ_NEXT_BROTHER_PTR(a1),a1
	cmp.l #0,a1
	bne.s .cherche_fenetre_toppable
.pas_de_fenetre:
	bra.s .fin

.there_is_one_toppable:

	save.l a0

	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	move.w #WM_TOPPED,bmsg_msgid(a0)
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a1),bmsg_handle(a0)
	moveq #16,d0		; longueur du message
	move.w #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	load.l a0
.fin:
.toppable:
	ifd MDL_COLORS
	save.l a0
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	load.l a0
	endc	; ifd MDL_COLORS

.pas_ontop_pour_fenetre_fille:

	move.l a0,(GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[a0,GWVA_OBJ_FATHER_PTR])

.fenetre_plus_top:
	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_ONTOPPED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_ONTOPPED

.pas_ontop_car_on_ontop_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_REDRAW_PART_CONTENTS
; Asm label   : GWVA_WIND_PRG_REDRAW_PART_CONTENTS
; Description : Mthode de redessin d'une partie du contenu de la fentre
;
; Rq  : Pas de ON_REDRAW ni de REDRAWN
;
; in  : a0.l = pointeur sur la fentre
; in  : d0.w = x
; in  : d1.w = y
; in  : d2.l = [ width.w | height.w ] de la zone  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_ROOT_APPL_WRITE_FAILED si le
;	   message n'a pu tre dlivr
;
; 08/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_REDRAW_PART_CONTENTS:
; pas de before

	;-----------------------------------;

	save.l a0/d0-d2

	move.w d2,d3
	swap d2

	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a1
	move.w #WM_REDRAW,bmsg_msgid(a1)
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),bmsg_handle(a1)
	movem.w d0-d3,bmsg_xywh(a1)

	moveq #16,d0		; longueur du message
	move.w #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	move.l a1,a0
	bsr GWVA_ROOT_SEND_GEM_MESSAGE

	load.l a0/d0-d2

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS
; Asm label   : GWVA_WIND_PRG_REDRAW_ALL_CONTENTS
; Description : Mthode effectuant le redessin du contenu de la fentre
;
; Rq  : Pas de ON_REDRAW ni de REDRAWN
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_ROOT_APPL_WRITE_FAILED si
;	   le message n'a pu tre dlivr
;
; 08/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_REDRAW_ALL_CONTENTS:
; pas de before

	;-----------------------------------;

	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
	swap d2
	move.w d3,d2
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_REDRAW_PART_CONTENTS

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_FULL
; Asm label   : GWVA_WIND_PRG_FULL
; Description : demande de Full d'une fentre
;
; Rq  : Il faut prendre la taille maximale de l'cran, borne au contents
; Rq  : et rectifi en fonction du type (ex. wind_texte)
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  fuller
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 01/03/98 : Cration
; 14/06/98 : Modification par la surcharge de cette mthode par la fentre RSC (namify)
;------------------------------------------------------------------------------
GWVA_WIND_PRG_FULL:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_FULL
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_full_car_on_full_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}
	bne.s .full

	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}	; full

	bsr GWVA_WIND_RETURN_MAX_EXT_ABS_POS_SIZE
	bsr GWVA_WIND_REDUCE_EXT_WH_TO_CONTENTS
	; a0 = ptr, sortie : d0/d3 => x,y,w,h max ext

	bra.s .common_end

.full:	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}	; position prcdente

	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_PREVXYWH
	load.l a0

	movem.w int_out+2,d0-d3			; x,y,w,h
	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	beq.s .pas_namifiee2

	add.w GWVA_WIND_OBJ_INT_VISIBLE_H(a0),d3
	add GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3

.pas_namifiee2:

.common_end:bsr GWVA_WIND_CALC_AND_SET_SIZE_WIND

.envoyer_fulled:

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_FULLED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_FULLED

.pas_full_car_on_full_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_NAMIFY_UNAMIFY
; Asm label   : GWVA_WIND_PRG_NAMIFY_UNAMIFY
; Description : demande de namification/dnamification d'une fentre
;
; Rq  : La fentre ne devrait avoir aucun gadgets que dans sa partie titre
; Rq  : Cette routine inverse l'tat courant namifi/non-namifi
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 01/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_NAMIFY_UNAMIFY:

	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}	; la fentre n'est plus en full

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	beq.s .pas_namifiee

	; on la dnamifie
	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE	; d0-d3 = position, taille externe

	save.l a0

	movem.w d0-d3,int_in+4
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_CURRXYWH

	ifd MDL_COLORS
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	endc	; ifd MDL_COLORS

	load.l a0

	bra .fin_commune

.pas_namifiee:
	; on la namifie illico
	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}

	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}	; plus de curseur texte
	endc

	; int -> externe
	save.l a0
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1	; la vraie position intrieure

	move.w GWVA_WIND_OBJ_FLAGS(a0),d4

	wind_calc #0,d4,d0,d1,d2,#0
	move.l int_out+2,int_in+4
	move.l int_out+6,int_in+8
	move.l (sp),a0
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_CURRXYWH

	ifd MDL_COLORS
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	endc	; ifd MDL_COLORS

	load.l a0
.fin_commune:

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_SET_HSLIDER
; Asm label   : GWVA_WIND_PRG_SET_HSLIDER
; Description : Dtermine la position et la taille du slider horizontal de la 
; Description : fentre
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet fentre
; in  : d0.w = largeur total de la page
; in  : d1.w = indice de la premire colonne vue
; in  : d2.w = largeur vue de la page
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 22/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_SET_HSLIDER:
; pas de before

	;-----------------------------------;

	btst #HSLIDE-8,GWVA_WIND_OBJ_FLAGS(a0)	; slide horizontal
	beq.w .pas_hslide

	cmp.w d2,d0
	bgt.s .not_full	; tout est afficher dans la fentre ?
	move.w #1000,d3
	bra.s .wind_pos
.not_full:	move.w d2,d3
	mulu #1000,d3	; non -> taille slide =
	divu d0,d3		; (ce que l'on voit) / (taille document) pour 1000
.wind_pos:
	move.w d0,d5
	sub.w d2,d5
	tst d5		; d3 = htotal-hvue
	beq.s .zero1

	move.w d1,d4
	mulu #1000,d4	; d4 = premire ligne vue
	divs d5,d4		; position du slider
	cmp.w #1,d4
	bge.s .pos1
.zero1:	moveq #1,d4		; ?ERROR? clr d4
.pos1:	cmp.w #1000,d4
	ble.s .inf1
	move.w #1000,d4
.inf1:

; d3.w : taille slider
; d4.w : position slider

	save.w d3/d4
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_HSLSIZE
	move.w int_out+1*2,d0			; taille actuelle
	load.l a0
	save.l d0/a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_HSLIDE
	move.w int_out+1*2,d1			; position actuelle
	load.l d0/a0
	load.w d3/d4

	cmp.w d0,d3
	bne.s .changement_taille_slider
	cmp.w d1,d4
	beq.s .pas_changement_position_slider
.changement_taille_slider:

	save.l d3/a0
	move.w d4,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_HSLIDE
	load.l d3/a0
	save.l a0
	move.w d3,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_HSLSIZE
	load.l a0
.pas_changement_position_slider:

.pas_hslide:

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_SET_VSLIDER
; Asm label   : GWVA_WIND_PRG_SET_VSLIDER
; Description : Mthode pour dterminer la position du slider vertical de la
; Description : fentre et le met  jour si ncessaire
;
; Rq  : 
;
; in  : a0.l = pointeur sur l'objet fentre
; in  : d0.w = hauteur total de la page
; in  : d1.w = indice de la premire ligne vue
; in  : d2.w = hauteur vue de la page
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 22/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_SET_VSLIDER:
; pas de before

	;-----------------------------------;
	btst #VSLIDE-8,GWVA_WIND_OBJ_FLAGS(a0)	; slide vertical ?
	beq.w .pas_vslide

	cmp.w d2,d0
	bgt.s .not_full	; tout est afficher dans la fentre ?
	move.w #1000,d3
	bra.s .wind_pos
.not_full:	move.w d2,d3
	mulu #1000,d3	; non -> taille slide =
	divu d0,d3		; (ce que l'on voit) / (taille document) pour 1000
.wind_pos:
	move.w d0,d5
	sub.w d2,d5
	tst.w d5		; d3 = htotal-hvue
	beq.s .zero1

	move.w d1,d4
	mulu #1000,d4	; d4 = premire ligne vue
	divs d5,d4		; position du slider
	cmp.w #1,d4
	bge.s .pos1
.zero1:	moveq #1,d4		; ?ERROR? clr d4
.pos1:	cmp.w #1000,d4
	ble.s .inf1
	move.w #1000,d4
.inf1:

; d3.w : taille slider
; d4.w : position slider

	save.w d3/d4
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLSIZE
	move.w int_out+1*2,d0			; taille actuelle
	load.l a0
	save.l d0/a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLIDE
	move.w int_out+1*2,d1			; position actuelle
	load.l d0/a0
	load.w d3/d4

	cmp.w d0,d3
	bne.s .changement_taille_slider
	cmp.w d1,d4
	beq.s .pas_changement_position_slider
.changement_taille_slider:

	save.l d3/a0
	move.w d4,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLIDE
	load.l d3/a0
	save.l a0
	move.w d3,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLSIZE
	load.l a0
.pas_changement_position_slider:

.pas_vslide:

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_CLICK
; Asm label   : GWVA_WIND_PRG_CLICK
; Description : Gestion du clic dans une fentre
;
; Rq  : redistribu par la fenetre WAPP
; Rq  : sert pour les fentres de type connu V.A; si vous voulez un clic dans une
; Rq  : fentre d'un type nouveau, alors remplacez(surchargez) cette mthode
;
; in  : a0.l = pointeur sur l'objet fentre
; in  : d0.l = [ X.w | handle fentre gem.w ]
; in  : d1.l = [ mouse button.w | Y.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED si le click est pour la fentre
;	   ou GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_CLICK_IS_CONSUMED ou
; 	   GWVA_WIND_CTE_CLICK_IS_NOT_CONSUMED
;
; 14/01/98 : Cration
; 26/03/98 : Changement de l'infertace pour le form_clic
; 30/07/98 : Prise en compte de l'hritage
;------------------------------------------------------------------------------
GWVA_WIND_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WIND_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_wclick_car_on_wclick_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	ifd MDL_CHILDREN_WINDOWS

	; recherche de la fentre fille sous le clic
	movem.w GWVA_APP_OBJ_EVNT_MULTI_MX,d0-d1
	save.l a0
	bsr GWVA_WIND_OBJ_PRG_RETURN_CHILD_UNDER_XY
	tst d7 ; 'tention tester NO_ERROR
	beq.s .i_found_the_child_window

	load.l a0
	bra .not_found_in_any_child_window

.i_found_the_child_window:
	lea 4(sp),sp

	endc	; ifd MDL_CHILDREN_WINDOWS

	save.l d0-d2/a0
	bsr GWVA_WIND_UPDATE_MENU_AND_FORM
	load.l d0-d2/a0

	;--------------------

	ifd MDL_WIND_MENU
	; est-ce le menu ?

	; attention  d0-d2/a0 tout du long ..

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
.ptr_menu_non_nul:

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_MENU_CLICK
	load.l a0

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .menu_has_consumed_click

.no_menu:
	endc	; ifd MDL_WIND_MENU

	;--------------------

	bra.s .le_clic_n_est_pas_consomme

	;--------------------

; Si on clique dans une fentre, elle devient focuse

	move.l a0,(GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[a0,GWVA_OBJ_FATHER_PTR])

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WIND_CLICKED

.menu_has_consumed_click:
.pas_wclick_car_on_wclick_consome:
	move.w #GWVA_WIND_CTE_CLICK_IS_CONSUMED,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.le_clic_n_est_pas_consomme:
	move.w #GWVA_WIND_CTE_CLICK_IS_NOT_CONSUMED,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.not_found_in_any_child_window:
.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WIND_PRG_WM_REDRAW
; Description : Ordre de redessin d'une zone de fentre
;
; Rq  : Test si le message est ddi  cette fentre, si la fentre est ouverte,
; Rq  : "namifie" et si le contenu est dans la zone voulue
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED si le message est pour cette fentre
;	   GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_REDRAW_IS_POSSIBLE
; 	   GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE
;
; 21/06/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_PRG_WM_REDRAW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

	;---------------

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; fentre GEM ouverte ?
	beq.w .no_redraw_cause_closed

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; fentre GEM namifi ?
	bne.w .no_redraw_cause_namified

	;---------------

	ifd MDL_WIND_MENU

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
.ptr_menu_non_nul:

	save.l d0/a1-a2

	save.l a1
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	load.l a1
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3

	; intersection du rectangle de la fentre
	movem.w bmsg_xywh(a1),d4-d7

	bsr GWVA_WIND_INTERSEC_REC	; avec la zone  redessiner
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_intersection_avec_menu	; pas d'intersection = pas de redraw du menu

	save.l a0
	swap d2
	move.w d3,d2
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WM_REDRAW
	load.l a0
.pas_intersection_avec_menu:
	load.l d0/a1-a2
	
.no_menu:
	endc 	; ifd MDL_WIND_MENU

	;---------------

	save.l d0/a1-a2

	save.l a1
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE ;d0-d3 uniquement modifis
	load.l a1

	; intersection du rectangle prcdent
	movem.w bmsg_xywh(a1),d4-d7
	bsr GWVA_WIND_INTERSEC_REC		; avec la fentre mre
	move.w d0,d4
	load.l d0/a1-a2

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_intersection_avec_cette_fenetre

; On stocke le rsultat dans le buffer GEM ... ?

	save.w d0
	move.w d4,d0
	movem.w d0-d3,bmsg_xywh(a1)
	load.w d0

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_REDRAWED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

	moveq #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.pas_intersection_avec_cette_fenetre:
.no_redraw_cause_namified:
.no_redraw_cause_closed:
	moveq #GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE,d7
.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	ifeq 1

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WIND_PRG_WM_REDRAW
; Description : Ordre de redessin d'une zone de fentre
;
; Rq  : Sur un move, si la fentre n'a rien  redessiner, le GEM prend pour
; Rq  : lui l'ventuel redessin s'il le peut.
; Rq  : Attention : les redraws peuvent tre mergs dans le pipe GEM. (optimiss)
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 12/02/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_PRG_WM_REDRAW:

	GWVA_CALL_METHOD	#GWVA_METHOD_ON_WM_REDRAW,#GWVA_MODE_SEARCH_EXEC_LOCAL_ONLY
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

; On commence par traiter les spcificits de la fentre GEM qui a gnr le message WM_REDRAW

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; fentre GEM ouverte ?
	beq.s .no_redraw_cause_closed

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; fentre GEM namifi ?
	bne.s .no_redraw_cause_namified

;------------------------------------------------------------------------------

	movem.w bmsg_xywh(a1),d0-d3

	; intersection avec le bureau avec la zone  redessiner
	movem.w ([GWVA_ROOT_PTR_WAPP.l],GWVA_WIND_OBJ_INT_DX),d4-d7
	bsr GWVA_WIND_INTERSEC_REC	; => d0-d3 modifis =zone correcte

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .zone_redraw_pas_dans_bureau

	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_BOX	; zone  redessiner demande par le GEM

	save.l a1-a2
	bsr GWVA_WIND_UPDATE_MENU_AND_FORM
	load.l a1-a2

;------------------------------------------------------------------------------

	save.l a0-a2
	wind_update #BEG_UPDATE			; on rserve l'cran

	movem.l (sp),a0-a2
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_FIRSTXYWH	; on demande le premier rectangle GEM
	load.l a0-a2

	; ==> boucle 1 : sur tous les rectangles

.draw_all_rectangles:
	tst.l int_out+3*2		; largeur & hauteur nulle ?
	beq.s .no_more_rectangle

	movem.w int_out+1*2,d0-d3	; position et taille du rectangle GEM de la fentre

; On dtermine en premier la zone qu'il faut effectivement redessiner

	; intersection du rectangle de la fentre
	movem.w GWVA_WIND_OBJ_REDRAW_BOX,d4-d7
	bsr GWVA_WIND_INTERSEC_REC	; avec la zone  redessiner
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_intersection_zone_gem	; pas d'intersection = pas de redraw ncessaire dans cette zone
	; -> d0-d3 = nouveau rectangle de redraw

	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP_WINDGEM	; x,y,w,h de la zone  redessiner pour la fentre GEM

	; ==> boucle 2 : sur toutes les fentres filles

	clr.w d0		; profondeur relative : 0
	save.l d0/a0-a2
.redraw_all_child_windows:

	ifd MDL_WIND_MENU

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
.ptr_menu_non_nul:

	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3

	; intersection du rectangle de la fentre
	movem.w GWVA_WIND_OBJ_REDRAW_CLIP_WINDGEM,d4-d7
	bsr GWVA_WIND_INTERSEC_REC	; avec la zone  redessiner
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_intersection_avec_menu	; pas d'intersection = pas de redraw du menu

	save.l a0
	swap d2
	move.w d3,d2
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHODNTEST	#GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX,#GWVA_MODE_SEARCH_EXEC_UNIQUE
	load.l a0
.pas_intersection_avec_menu:
.no_menu:
	endc 	; ifd MDL_WIND_MENU
	
	bsr GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE ;d0-d3 uniquement modifis
	tst d2
	ble.s .bord_gauche_pas_meme_visible
	tst d3
	ble.s .bord_haut_pas_meme_visible

	; intersection du rectangle prcdent
	movem.w GWVA_WIND_OBJ_REDRAW_CLIP_WINDGEM,d4-d7
	bsr GWVA_WIND_INTERSEC_REC		; avec la fentre mre
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_intersection_avec_cette_fille	; pas d'intersection avec la fentre mre = la zone est en dehors ...
	; -> d0-d3 = rectangle effectif de redraw

; Pas de GWVA_CALL_METHODNTEST car le contenu n'existe pas forcment (cas des CUSTOM)
	swap d2
	move.w d3,d2
	GWVA_CALL_METHOD2	#GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX,#GWVA_MODE_EXEC_METHOD

.pas_intersection_avec_cette_fille:
.bord_gauche_pas_meme_visible:
.bord_haut_pas_meme_visible:

	ifd MDL_CHILDREN_WINDOWS

	movem.l (sp),d0/a1
	bsr GWVA_WIND_OBJ_PRG_RETURN_NEXT_FAMILY_MEMBER
	tst d0
	ble.s .retour_a_la_fenetre_mere_son_frere_ou_au_dessus
	load.l d1/a1
	save.l d0/a1	; on restocke d0
	bra.s .redraw_all_child_windows

	endc	; ifd MDL_CHILDREN_WINDOWS

.retour_a_la_fenetre_mere_son_frere_ou_au_dessus:
	load.l d0/a0-a2		; d0 : on s'en fiche

.pas_intersection_zone_gem:
	save.l a0-a2
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_NEXTXYWH
	load.l a0-a2

	bra .draw_all_rectangles

.no_more_rectangle:

	ifd MDL_WIND_FORM		; END REDRAW FORM

	ifd MDL_FORM_EDITABLE_TEXT2

	ifnd PATCH_WFORM_CUSTOM_EDITABLE_TEXT

	cmp.w #GWVA_WIND_TYPE_FORM,GWVA_WIND_OBJ_TYPE(a0)
	bne.s .pas_form3

	save.l a0
	bsr GWVA_WIND_OBJ_PRG_RETURN_TOP_WINDOW
	load.l a0
	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0
	bne.s .no_top

	btst #GWVA_WIN_BIT_CURS,GWVA_WIND_OBJ_STATUS+1(a0)
	bne.s .curseur_deja_affiche

	save.l a0
	v_hide_c
	move.l (sp),a0

	bsr GWVA_WIND_OBJ_PRG_REDRAW_ED_TXT_CURSOR

	v_show_c #1
	load.l a0

	bset #GWVA_WIN_BIT_CURS,GWVA_WIND_OBJ_STATUS+1(a0)

.curseur_deja_affiche:
.no_top:
.pas_form3:
	endc	; ifnd PATCH_WFORM_CUSTOM_EDITABLE_TEXT

	endc	; ifd MDL_FORM_EDITABLE_TEXT

	endc	; ifd MDL_WIND_FORM

	save.l a0
	wind_update #END_UPDATE
	load.l a0

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_REDRAWED

	GWVA_CALL_METHOD	#GWVA_METHOD_WM_REDRAWN,#GWVA_MODE_SEARCH_EXEC_LOCAL_ONLY

.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.zone_redraw_pas_dans_bureau:
.no_redraw_cause_namified:
.no_redraw_cause_closed:
.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	endc	; ifeq 1

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_SIZE
; Asm label   : GWVA_WIND_PRG_SIZE
; Method name : GWVA_METHOD_WM_MOVE
; Asm label   : GWVA_WIND_PRG_MOVE
; Description : Dplacement d'une fentre avec un ventuel changement de taille
;
; Rq  : Le Gem ne peut donner que des coords dans l'cran, mais plus grandes
; Rq  : que le minimum que l'on s'tait fix (attention)
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  dplacer/redimensionner
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 10/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_SIZE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_SIZE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_size_car_on_size_consome

	;-----------------------------------;

	save.l a1-a2/d0
	bsr.s GWVA_WIND_PRG_COMMON_SIZE_AND_MOVE
	load.l a1-a2/d0

	cmp.w #GWVA_PRGRET_NOT_CONSUMED,d6
	beq.s .pas_consomme

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_SIZED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_SIZED

.pas_size_car_on_size_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
.pas_consomme:
	rts

	;-----------------------------------;

GWVA_WIND_PRG_MOVE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_MOVE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_move_car_on_move_consome

	;-----------------------------------;

	save.l a1-a2/d0
	bsr.s GWVA_WIND_PRG_COMMON_SIZE_AND_MOVE
	load.l a1-a2/d0

	cmp.w #GWVA_PRGRET_NOT_CONSUMED,d6
	beq.s .pas_consomme

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_MOVED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_MOVED

.pas_move_car_on_move_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
.pas_consomme:
	rts

	;------------------------------------------------------------------;

GWVA_WIND_PRG_COMMON_SIZE_AND_MOVE:
	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.s .je_ne_suis_pas_concerne_par_ce_msg

	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_FULL:1}	; la fentre n'est plus en full

	save.l a1
	bsr GWVA_WIND_RETURN_MAX_EXT_ABS_POS_SIZE
	bsr GWVA_WIND_REDUCE_EXT_WH_TO_CONTENTS
	load.l a1

	; on veut uniquement max w et h
	move.w d2,d4
	move.w d3,d5

	; est-ce que on a toujours a1 (dans le cas d'appel direct ...) ?_ERROR_?
	movem.w bmsg_xywh(a1),d0-d3	; x,y,w,h

*	movem.w GWVA_WIND_OBJ_INTERNAL_MAX_W(a0),d4-d5
*	add GWVA_WIND_OBJ_MENU_HEIGHT(a0),d5
*	move.w GWVA_WIND_OBJ_FLAGS(a0),d6
*	; int -> ext
*	save.l d0-d3/a0
*	wind_calc #0,d6,d0,d1,d4,d5
*	load.l d0-d3/a0
*	movem.w int_out+6,d4-d5			; nouvelle taille externe

	cmp.w d4,d2
	ble.s .pas_trop_large
	move.w d4,d2
.pas_trop_large:
	cmp.w d5,d3
	ble.s .pas_trop_haut
	move.w d5,d3
.pas_trop_haut:

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	beq.s .pas_namifiee

	save.w d0-d2
	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE
	load.w d0-d2	; d3 non modifi pour qu'il calcule la taille interne normalement
.pas_namifiee:

	bsr GWVA_WIND_CALC_AND_SET_SIZE_WIND

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_TOP
; Asm label   : GWVA_WIND_PRG_TOP
; Method name : GWVA_METHOD_WM_NEWTOP
; Asm label   : GWVA_WIND_PRG_NEWTOP
; Description : Mthode toppant une fentre
;
; in  : a0   = pointeur sur l'objet fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  topper
; 
; 08/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_NEWTOP:
GWVA_WIND_PRG_TOP:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_TOP
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_top_car_on_top_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	cmp.w #GWVA_CLASS_WIND.APP,(GWVA_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	bne.s .pas_top_pour_fenetre_fille

	tst GWVA_WIND_OBJ_TOPABLE_STATE(a0)		; untoppable ?
	bgt .untoppable
					; un_untoppable ?
	blt.s .un_untoppable	; passe droit au cas oui il y aurait 2 un_untoppable

	move.l GWVA_ROOT_PTR_WAPP,a1
	move.l GWVA_OBJ_FIRST_SON_PTR(a1),a1
	cmp.l #0,a1
	beq.s .pas_de_fenetre

.cherche_fenetre_un_untoppable:
	cmp.l a0,a1
	beq.s .pas_moi
	bftst GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_OPEN:1}	; est-elle ouverte ?
	beq.s .closed
	tst GWVA_WIND_OBJ_TOPABLE_STATE(a1)		; est-elle un_untoppable ?
	blt.s .there_is_one_ununtoppable
.closed:
.pas_moi:
	move.l GWVA_OBJ_NEXT_BROTHER_PTR(a1),a1
	cmp.l #0,a1
	bne.s .cherche_fenetre_un_untoppable
.pas_de_fenetre:

.un_untoppable:
	save.l a0

	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_TOP

	ifd MDL_COLORS
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	endc	; ifd MDL_COLORS

	load.l a0

.pas_top_pour_fenetre_fille:

	move.l a0,(GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[a0,GWVA_OBJ_FATHER_PTR])

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_WM_TOPPED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_TOPPED

.pas_top_car_on_top_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.there_is_one_ununtoppable:
.untoppable:
	load.l d0/a0-a2
.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_OPEN
; Asm label   : GWVA_WIND_PRG_OPEN
; Description : Ouverture d'une fentre
;
; Rq  : ouvre l'arborescence  partir de cet enfant mais pas au dessus
; Rq  : Une fentre ne peut tre ouverte que si sa mre l'est.
;
; in  : a0.l = pointeur sur la fentre
; in  : d0.w = handle GEM de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;	   ou GWVA_ERROR_WIND_BAD_HANDLE
;	   ou GWVA_ERROR_WIND_OPEN
;	   ou GWVA_ERROR_WIND_MOTHER_NOT_OPENED
;
; 08/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_OPEN:

	ifd MDL_CHILDREN_WINDOWS

	save.l a0
	clr.w -(sp) 			; niveau relatif
.open_all_child_windows:
	bsr GWVA_WIND_OBJ_PRG_OPEN_ONE_FAMILY_MEMBER

	load.w d0

	tst d7 ; 'tention tester NO_ERROR
	bne.s .erreur_ouverture_fenetre

	bsr GWVA_WIND_OBJ_PRG_RETURN_NEXT_FAMILY_MEMBER
	tst d0
	ble.s .retour_a_la_fenetre_mere_son_frere_ou_au_dessus
	save.w d0
	bra.s .open_all_child_windows

.retour_a_la_fenetre_mere_son_frere_ou_au_dessus:
	clr.w d7

.erreur_ouverture_fenetre:
	load.l a0
	rts

		*--------------------------*

GWVA_WIND_OBJ_PRG_OPEN_ONE_FAMILY_MEMBER:	; a0=ptr structure mre

	endc	; ifd MDL_CHILDREN_WINDOWS

	;-----------------------------------;

	ifd OPT_GWVA_DEBUG_ERROR
	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a0)
	bne.s .pas_fenetre_application
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_BAD_OBJECT_METHOD
.pas_fenetre_application:
	endc	; OPT_GWVA_DEBUG_ERROR

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_OPEN
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_open_car_on_open_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	; Une fentre ne peut tre ouverte que si sa mre l'est.
	bftst GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_OPEN:1}
	beq.w .mother_window_not_opened

	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)
	beq.w .bad_handle

	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; on set+test
	bne.w .deja_ouvert

	; fentre mre est une fille du bureau ?
	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a1)
	bne.w .pas_open_pour_fenetre_fille

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}	; la fentre est iconifie ?
	bne.w .fenetre_iconifiee

	save.l a0

	bsr GWVA_ROOT_HIDE_MOUSE

	move.l (sp),a0

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE	; d0-d3 = position, taille externe

	wind_open GWVA_WIND_OBJ_GEM_HANDLE(a0),d0,d1,d2,d3
	save.w d0
	bsr GWVA_ROOT_SHOW_MOUSE
	load.w d0

	load.l a0

	tst d0
	beq.w .erreur_open

	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_CURRXYWH	; get external size
	load.l a0
	
; si la taille externe affiche n'est pas celle qui a t demande
	movem.w int_out+1*2,d0-d3			; taille externe, absolue

	bsr GWVA_WIND_CALC_AND_SET_SIZE_WIND	; on force quand mme

.fenetre_iconifiee:
.pas_open_pour_fenetre_fille:

	tst GWVA_WIND_OBJ_TOPABLE_STATE(a0)		; untoppable ?
	ble.s .toppable

	; elle est untoppable, il faut en topper une autre qui soir ouverte et toppable
	move.l GWVA_ROOT_PTR_WAPP,a1
	move.l GWVA_OBJ_FIRST_SON_PTR(a1),a1
	cmp.l #0,a1
	beq.s .pas_de_fenetre

.cherche_fenetre_toppable:
	bftst GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_OPEN:1}	; est-elle ouverte ?
	beq.s .closed
	tst GWVA_WIND_OBJ_TOPABLE_STATE(a1)		; est-elle untoppable ?
	ble.s .there_is_one_toppable
.closed:
	move.l GWVA_OBJ_NEXT_BROTHER_PTR(a1),a1
	cmp.l #0,a1
	bne.s .cherche_fenetre_toppable
.pas_de_fenetre:
	bra.s .fin_pas_trouve

.there_is_one_toppable:

	save.l a0
	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	move.w #WM_TOPPED,bmsg_msgid(a0)
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a1),bmsg_handle(a0)
	move.w #16,d0
	move.w #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	load.l a0

.fin_pas_trouve:
.toppable:

	;------------ Ouverture du menu de la fentre -------------

	ifd MDL_WIND_MENU

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
.ptr_menu_non_nul:

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN
	load.l a0
.no_menu:
	endc	; ifd MDL_WIND_MENU

	;------------ On change la plalette couleur -------------------

	ifd MDL_COLORS
	save.l a0
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	load.l a0
	endc	; ifd MDL_COLORS

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_OPENED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_OPENED

	moveq #GWVA_NO_ERROR_GENERIC,d7

.pas_open_car_on_open_consome:
.common_ending:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

.deja_ouvert:
	; on toppe la fentre dans ce cas
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; les mthodes wind prennent d0 en entre
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WM_TOP
	moveq #GWVA_NO_ERROR_GENERIC,d7
	bra.s .common_ending

.bad_handle:
	move #GWVA_ERROR_WIND_BAD_HANDLE,d7
	bra.s .common_ending

.erreur_open:
	move #GWVA_ERROR_WIND_OPEN,d7
	bra.s .common_ending

.mother_window_not_opened:
	move.w #GWVA_ERROR_WIND_MOTHER_NOT_OPENED,d7
	bra.s .common_ending

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CLOSE
; Asm label   : GWVA_WIND_PRG_CLOSE
; Description : Fermeture d'une fentre
;
; Rq  : ferme toutes les fentres  partir de cet enfant mais pas au dessus
; Rq  : ferme par consquent toutes ses filles
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM ou 0.l si act. directe
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  fermer
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 08/02/98 : Cration
; 24/02/98 : Ajoutt l'auto-delete
;------------------------------------------------------------------------------
GWVA_WIND_PRG_CLOSE:		; a0=ptr sur structure

	ifd MDL_CHILDREN_WINDOWS

	save.l a0
	clr.w -(sp) 			; niveau relatif
.close_all_child_windows:
	bsr GWVA_WIND_OBJ_PRG_CLOSE_ONE_FAMILY_MEMBER

	; on ne teste pas l'erreur : tant pis, car il faut quand mme fermer les autres

	load.w d0
	bsr GWVA_WIND_OBJ_PRG_RETURN_NEXT_FAMILY_MEMBER
	tst d0
	ble.s .retour_a_la_fenetre_mere_son_frere_ou_au_dessus
	save.w d0
	bra.s .close_all_child_windows

.retour_a_la_fenetre_mere_son_frere_ou_au_dessus:

	load.l a0
	rts

		*--------------------------*

GWVA_WIND_OBJ_PRG_CLOSE_ONE_FAMILY_MEMBER:	; a0=ptr sur structure

	endc	; ifd MDL_CHILDREN_WINDOWS

	ifd OPT_GWVA_DEBUG_ERROR
	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a0)
	bne.s .pas_fenetre_application
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_BAD_OBJECT_METHOD
.pas_fenetre_application:
	endc	; OPT_GWVA_DEBUG_ERROR

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_CLOSE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.w .pas_close_car_on_close_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne.w .je_ne_suis_pas_concerne_par_ce_msg

	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)
	beq.w .fenetre_non_initialisee

	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}	; curseur effac
	endc

	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; la fentre est non namifie

	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; la fentre est ferme
	beq.w .deja_ferme

	save.l d0/a0-a2

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_COPYXY:1}
	beq.s .pas_copy_pos

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE	; d0-d3 = position, taille externe
	bsr GWVA_WIND_CONVERT_ABSOLUTE_RELATIVE_POS
	movem.w d0-d1,GWVA_WIND_OBJ_FIRST_EXT_DX(a0)	; nouvelle position externe
	move.l GWVA_WIND_OBJ_INT_VISIBLE_W(a0),GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0)
.pas_copy_pos:

	;------------ Fermeture du menu de la fentre -------------

	ifd MDL_WIND_MENU

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
.ptr_menu_non_nul:

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_CLOSE
	load.l a0
.no_menu:
	endc	; ifd MDL_WIND_MENU

	ifd MDL_CHILDREN_WINDOWS

	cmp.w #GWVA_WIND_CLASS_APPLICATION,(GWVA_WIND_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	bne.s .pas_ferme_fenetre_fille

	endc	; ifd MDL_CHILDREN_WINDOWS

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}	; la fentre est iconifie ?
	bne.s .fenetre_iconifiee

	save.l a0
	wind_close <GWVA_WIND_OBJ_GEM_HANDLE(a0)>

	ifd MDL_COLORS
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	endc	; ifd MDL_COLORS

	load.l a0

.pas_ferme_fenetre_fille:
	cmp.l (GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[GWVA_OBJ_FATHER_PTR,a0]),a0
	bne.s .je_ne_suis_pas_focusee
	clr.l (GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[a0,GWVA_OBJ_FATHER_PTR])
.je_ne_suis_pas_focusee:

	; pour le fenetre iconifie : ne pas faire de clr.l au moment de sa dsiconification
	; car on a fait repointer le FOCUSED_CHILD sur la fentre dsiconife avant CLOSE
.fenetre_iconifiee:

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_CLOSED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CLOSED

.deja_ferme:
	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AUTODEL:1}
	beq.s .pas_automatic_delete

; ?_ERROR_? : Ce appel  GWVA_ROOT_DELETE_OBJECT execute en fait un appel de type 
; GWVA_CALL_METHOD_OTHER_OBJ sur la fentre. Normalement, on n'a pas le droit de
; s'appeler soit mme : on ne peut xecuter que des mthodes de sa classe.

	bsr GWVA_WIND_DELETE_ONE_WIND

.pas_automatic_delete:

.pas_close_car_on_close_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.fenetre_non_initialisee:
.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY
; Asm label   : GWVA_WIND_PRG_MOVE_SLIDERS_WITH_KEY
; Description : Mthode transformant les touches de flche en un vnement arrowed
;
; Rq  : Envoie d'un message GEM WM_ARROWED
;
; in  : a0.l = pointeur sur l'objet fentre
; in  : d0.w = [ Key code.w | Ascii code ] de la touche
; out : d6.w = GWVA_PRGRET_CONSUMED ou GWVA_PRGRET_NOT_CONSUMED
;
; 26/04/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_PRG_MOVE_SLIDERS_WITH_KEY:
	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_KEY2ARROW:1}
	beq.s .pas_de_shortcut_arrow

	bftst GWVA_WIND_OBJ_FLAGS(a0){15-HSLIDE:6}
	beq.s .got_no_slide_arrow

	lea GWVA_WIND_SLIDERS_SHORTCUTS,a1
.search:	tst.l (a1)
	bmi.s .no_window_shortcut
	cmp.w (a1),d0
	beq.s .window_key
	add.w #2+2,a1
	bra.s .search

.window_key:
	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a2
	move.w #WM_ARROWED,bmsg_msgid(a2)
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),bmsg_handle(a2)
	move.w 2(a1),bmsg_arrowed_action(a2)
	moveq #16,d0		; longueur du message
	move.w #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	save.l a0
	move.l a2,a0
	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	load.l a0

	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

.no_window_shortcut:
.got_no_slide_arrow:
.pas_de_shortcut_arrow:
	move.w #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;-----------------------------------------------------------------------------;

	;!!!!!!!!!!!!!!!!!!!!!

	endc	; ifd MDL_WIND

	;!!!!!!!!!!!!!!!!!!!!!

;-----------------------------------------------------------------------------;

	DATA

	ifd MDL_WIND

GWVA_WIND_SLIDERS_SHORTCUTS:
	dc.w $48*256,WA_UPLINE
	dc.w $50*256,WA_DNLINE
	dc.w $4B*256,WA_LFLINE
	dc.w $4D*256,WA_RTLINE
	dc.w $48*256+'8',WA_UPPAGE
	dc.w $50*256+'2',WA_DNPAGE
	dc.w $4B*256+'4',WA_LFPAGE
	dc.w $4D*256+'6',WA_RTPAGE
	dc.l -1

	endc	; ifd MDL_WIND

;-----------------------------------------------------------------------------;

	BSS

	ifd MDL_WIND

*GWVA_WIND_OBJ_REDRAW_BOX:	ds.w 4	; intersec. bureau avec zone message
*GWVA_WIND_OBJ_REDRAW_CLIP_WINDGEM:	ds.w 4	; intersec. zone prcdente intersec. avec un rectangle de redraw

	endc	; ifd MDL_WIND

	TEXT

;-----------------------------------------------------------------------------;

