 ifnd GWVA_ROOT_CTE_STACK_SIZE
  fail	; Dfinissez la taille de la pile dans le .DEF : GWVA_ROOT_CTE_STACK_SIZE
  end
 endc

 ifnd GWVA_ROOT_MAX_PATH_LENGTH
  fail	; Dfinissez la longueur max d'un pathname dans le .DEF : GWVA_ROOT_MAX_PATH_LENGTH
  end
 endc

		;--------------------------

 ifnd GWVA_ROOT_DEFINE_VA_VERSION
  fail	; Dfinissez la version des librairies dans le .DEF : GWVA_ROOT_DEFINE_VA_VERSION
  end
 else
  ifne GWVA_ROOT_DEFINE_VA_VERSION-4
   fail	; Procurez-vous une version 4.x.y Visual Assembleur
   end
  endc
 endc

 ifnd GWVA_ROOT_DEFINE_VA_MAJOR
  fail	; Dfinissez le patchlevel majeur dans le .DEF : GWVA_ROOT_DEFINE_VA_MAJOR
  end
 else
  ifne GWVA_ROOT_DEFINE_VA_MAJOR-5
   fail	; Procurez-vous une version 4.5.y Visual Assembleur
   end
  endc
 endc	; ifnd GWVA_ROOT_DEFINE_VA_MAJOR

 ifnd GWVA_ROOT_DEFINE_VA_MINOR
  fail	; Dfinissez le patchlevel mineur dans le .DEF : GWVA_ROOT_DEFINE_VA_MINOR
  end
 else
  ifne GWVA_ROOT_DEFINE_VA_MINOR-1
   fail	; Harmonisez la version de votre source avec la version du Visual Assembleur 4.2.0 (cf. .DEF)
   end
  endc
 endc	; ifnd GWVA_ROOT_DEFINE_VA_MINOR

;-----------------------------------------------------------------------------------
; Les dpendances lies au GEM

 ifd MDL_GEM

  ifd MDL_TOS
   fail	; On ne peut pas mettre et MDL_GEM et MDL_TOS
   end
  endc

  ifd LIB_FSEL_BSS_FORM
   ifnd LIB_FILESELECTOR
    fail	; Vous avez besoin de la librairie LIB_FILESELECTOR
    end
   endc ; ifnd LIB_FILESELECTOR
  endc ; ifd LIB_FSEL_BSS_FORM

  ifd MDL_EVENTS

   ifnd GWVA_ROOT_CTE_MAX_TIMER
    fail	; Dfinissez le nombre maximal de timer voulu dans le .DEF : GWVA_ROOT_CTE_MAX_TIMER
    end
   endc

   ifne GWVA_ROOT_CTE_MAX_TIMER
    ifnd LIB_200HZ
     fail	; Si GWVA_ROOT_CTE_MAX_TIMER vaut au moins 1 alors dfinissez LIB_200HZ
     end
    endc
   endc	; ifne GWVA_ROOT_CTE_MAX_TIMER

   ifnd GWVA_ROOT_CTE_MAX_MOUSEZONE
    fail	; Dfinissez le nombre maximal de zone de surveillance souris voulu dans le .DEF : GWVA_ROOT_CTE_MAX_MOUSEZONE
    end
   endc

  endc		; ifd MDL_EVENTS

		;---------------

  ifnd MDL_EVENTS

   ifd MDL_MENU
    fail	; MDL_MENU ncessite MDL_EVENTS
    end
   endc

   ifd MDL_WIND
    fail	; MDL_WIND ncessite MDL_EVENTS
    end
   endc

  endc		; ifnd MDL_EVENTS

		;--------------------------

  ifd MDL_WIND

   ifd GWVA_APP_OBJ_MAX_NUMBER_WIND
    fail	; Le nombre maximal de fentres pour votre application n'est plus utile depuis la version 4.1 pl 5
    end
   endc

   ifd MDL_WIND_COPY_PASTE
    ifnd LIB_GEM_CLIPBOARD
     fail	; Pour utiliser MDL_WIND_COPY_PASTE dfinissez LIB_GEM_CLIPBOARD
     end
    endc
   endc

   ifnd MDL_CHILDREN_WINDOWS
    ifd MDL_WIND_TOOLBAR
     fail	; MDL_WIND_TOOLBAR ncessite MDL_CHILDREN_WINDOWS
     end
    endc
   endc

   ifd MDL_WIND_BITMAP
    ifnd MDL_COLORS
     fail	; Pour utiliser MDL_WIND_BITMAP dfinissez MDL_COLORS
     end
    endc
   endc

   ifd MDL_WIND_MENU
    iflt GWVA_ROOT_CTE_MAX_MOUSEZONE-3
     fail	; Pour utiliser MDL_WIND_MENU dfinissez GWVA_ROOT_CTE_MAX_MOUSEZONE >= 3
     end
    endc

    ifnd MDL_WIND_RSC_POPUP
     fail	; MDL_WIND_MENU ne prsente aucun intrt sans MDL_WIND_RSC_POPUP
     end
    endc

   endc

   ifd FORM_OBJ_PROGRESS
    ifnd LIB_DECI
     fail	; LIB_DECI est impratif pour l'obet PROGRESS
     end
    endc
   endc

   ifd MDL_FORM_EDITABLE_TEXT
    ifnd MDL_FORM_TEXT
     fail	; sans MDL_FORM_TEXT et des objets text, MDL_FORM_EDITABLE_TEXT vous est d'aucune utilit
     end
    endc
   endc

  endc	; ifd MDL_WIND

		;---------------

  ifnd MDL_WIND

   ifd MDL_WIND_TEXT
    fail	; MDL_WIND_TEXT ncessite MDL_WIND
    end
   endc

   ifd MDL_WIND_RSC
    fail	; MDL_WIND_RSC ncessite MDL_WIND
    end
   endc

   ifd MDL_WIND_BITMAP
    fail	; MDL_WIND_BITMAP ncessite MDL_WIND
    end
   endc

   ifd MDL_WIND_TOOLBAR
    fail	; MDL_WIND_TOOLBAR ncessite MDL_WIND
    end
   endc

  endc		; ifnd MDL_WIND

		;--------------------------

  ifnd MDL_WIND_RSC

   ifd MDL_WIND_FORM
    fail	; MDL_WIND_FORM ncessite MDL_WIND_RSC
    end
   endc

   ifd MDL_WIND_RSC_POPUP
    fail	; MDL_WIND_RSC_POPUP ncessite MDL_WIND_RSC
    end
   endc

  endc		; ifnd MDL_WIND_RSC

		;--------------------------

 else		; ifd MDL_GEM

  ifnd MDL_TOS
   fail	; Il faut imprativement MDL_GEM ou MDL_TOS
   end
  endc

  ifd OPT_GWVA_DEBUG_SEARCH_EXEC
   fail	; MDL_TOS est incompatible avec OPT_GWVA_DEBUG_SEARCH_EXEC
   end
  endc

  ifd MDL_COLORS
   fail	; MDL_TOS est incompatible avec MDL_COLORS
   end
  endc

  ifd MDL_EVENTS
   fail	; MDL_TOS est incompatible avec MDL_EVENTS
   end
  endc

  ifd GWVA_ROOT_CTE_MAX_TIMER
   fail	; GWVA_ROOT_CTE_MAX_TIMER est incompatible avec MDL_EVENTS
   end
  endc

  ifd GWVA_ROOT_CTE_MAX_MOUSEZONE
   fail	; GWVA_ROOT_CTE_MAX_MOUSEZONE est incompatible avec MDL_EVENTS
   end
  endc

  ifd MDL_MENU
   fail	; MDL_TOS est incompatible avec MDL_MENU
   end
  endc

  ifd MDL_WIND
   fail	; MDL_TOS est incompatible avec MDL_WIND
   end
  endc

  ifd MDL_WIND_TEXT
   fail	; MDL_TOS est incompatible avec MDL_WIND_TEXT
   end
  endc

  ifd MDL_WIND_RSC
   fail	; MDL_TOS est incompatible avec MDL_WIND_RSC
   end
  endc

  ifd MDL_WIND_FORM
   fail	; MDL_TOS est incompatible avec MDL_WIND_FORM
   end
  endc

  ifd MDL_WIND_BITMAP
   fail	; MDL_TOS est incompatible avec MDL_WIND_BITMAP
   end
  endc

  ifd MDL_WIND_MENU
   fail	; MDL_TOS est incompatible avec MDL_WIND_MENU
   end
  endc

  ifd LIB_FILESELECTOR
   fail	; MDL_TOS est incompatible avec LIB_FILESELECTOR
   end
  endc

 endc		; ifd MDL_GEM

;-----------------------------------------------------------------------------------
; Les librairies

 ifd LIB_XHDI
  ifnd LIB_COOKIE
   fail	; Pour utiliser LIB_XHDI dfinissez LIB_COOKIE
   end
  endc
 endc	; ifd LIB_XHDI

 ifd LIB_XHDI_INFOPARTITION

  ifnd LIB_XHDI_INQTARGET
   fail	; LIB_XHDI_READWRITE est impratif pour la librairie LIB_XHDI_INFOPARTITION
   end
  endc

  ifnd LIB_XHDI_READWRITE
   fail	;  LIB_XHDI_READWRITE est impratif pour la librairie LIB_XHDI_INFOPARTITION
   end
  endc

 endc		; LIB_XHDI_INFOPARTITION

 ifd LIB_SEARCH_SYSTEM_COOKIES
  ifnd LIB_COOKIE
   fail	; Pour utiliser LIB_SEARCH_SYSTEM_COOKIES dfinissez LIB_COOKIE
   end
  endc
 endc

 ifd LIB_INSTALL_COOKIE
  ifnd LIB_COOKIE
   fail	; Pour utiliser LIB_INSTALL_COOKIE dfinissez LIB_COOKIE
   end
  endc
 endc

		;--------------------------

 ifd OPT_GWVA_DEBUG_SEARCH_EXEC
  ifnd LIB_HEXA
   fail	; LIB_HEXA est impratif pour debugger avec OPT_GWVA_DEBUG_SEARCH_EXEC
   end
  endc
  ifnd LIB_DECI
   fail	; LIB_DECI est impratif pour debugger avec OPT_GWVA_DEBUG_SEARCH_EXEC
   end
  endc
 endc

 ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX
  ifnd OPT_GWVA_DEBUG_SEARCH_EXEC
   fail	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX a besoin de OPT_GWVA_DEBUG_SEARCH_EXEC
   end
  endc
 endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

 ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER
  ifnd OPT_GWVA_DEBUG_SEARCH_EXEC
   fail	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER a besoin de OPT_GWVA_DEBUG_SEARCH_EXEC
   end
  endc
  ifnd GWVA_DEBUG_MSG_MAX_SIZE
   fail	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER a besoin de GWVA_DEBUG_MSG_MAX_SIZE
   end
  endc
  ifnd GWVA_DEBUG_MAX_MSG_DEBUG_PENDING
   fail	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER a besoin de GWVA_DEBUG_MAX_MSG_DEBUG_PENDING
   end
  endc
 endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

;-----------------------------------------------------------------------------------
; Les fonctionnalits qui ont disparues

 ifd OPT_GWVA_WIND_FORM_CUSTOM_OBJECTS
  fail	; Cette fonctionalit n'existe plus, elle est supporte de facon intrinsque maintenant.
  end
 endc

 ifd FORM_OBJ_POPUP
  fail	; pour utiliser les menus popup : utilisez FORM_OBJ_MENU_POPUP
  end
 endc

 ifd OPT_DEBUG_VISUAL_WIND_OBJ_EVNT
  fail	; Cette fonctionalit n'existe plus.
  end
 endc

 ifd OPT_DEBUG_VISUAL_SYSTEM_EVNT
  fail	; Cette fonctionalit n'existe plus.
  end
 endc

 ifd OPT_DEBUG_VISUAL_FORM_OBJ_EVNT
  fail	; Cette fonctionalit n'existe plus.
  end
 endc

 ifd OPT_GWVA_DEBUG_VISUAL_SYSTEM_EVNT
  fail	; Cette fonctionalit n'existe plus.
  end
 endc

 ifd OPT_GWVA_DEBUG_VISUAL_WIND_OBJ_EVNT
  fail	; Cette fonctionalit n'existe plus.
  end
 endc

 ifd OPT_GWVA_DEBUG_VISUAL_FORM_OBJ_EVNT
  fail	; Cette fonctionalit n'existe plus.
  end
 endc

;-----------------------------------------------------------------------------------
; Les dfinitons intermdiaires

; MDL_CLONING_OR_MULTIFORM existe soit si MDL_GWVA_WIND_CLONING ou MDL_MULTIFORM existe
 ifd MDL_GWVA_WIND_CLONING
MDL_CLONING_OR_MULTIFORM
 else
  ifd MDL_MULTIFORM
MDL_CLONING_OR_MULTIFORM
  endc
 endc	;  ifd MDL_GWVA_WIND_CLONING

